/*****************************************************************************\
*	*
* shellapi.h -	SHELL.DLL functions, types, and definitions	*
*	*
* Copyright(c)Microsoft Corporation. All rights reserved.	*
*	*
\*****************************************************************************/

$ifndef __shellapi_inc__
$define __shellapi_inc__
$define _INC_SHELLAPI

$ifndef __specstrings
$include "SpecStrings.inc"
$endif

' Define API decoration for direct importing of DLL references.
$ifndef WINSHELLAPI

'$ ifndef _WIN64
'$include "pshpack1.inc"
'$ endif

typedef HDROP HANDLE

declare import, DragQueryFileA(HDROP hDrop, UINT iFile, LPSTR lpszFile, UINT cch),UINT
declare import, DragQueryFileW(HDROP hDrop, UINT iFile, LPWSTR lpszFile, UINT cch),UINT
$ifdef UNICODE
declare import, DragQueryFile alias DragQueryFileW(HDROP hDrop, UINT iFile, LPWSTR lpszFile, UINT cch),UINT
$else
declare import, DragQueryFile alias DragQueryFileA(HDROP hDrop, UINT iFile, LPSTR lpszFile, UINT cch),UINT
$endif

declare import, DragQueryPoint(HDROP hDrop, pointer lppt),BOOL
declare import, DragFinish(HDROP hDrop),HRESULT
declare import, DragAcceptFiles(HWND hWnd, BOOL fAccept),HRESULT

declare import, ShellExecuteA(HWND hwnd, LPCSTR lpOperation, LPCSTR lpFile, LPCSTR lpParameters,LPCSTR lpDirectory, INT nShowCmd),HINSTANCE
declare import, ShellExecuteW(HWND hwnd, LPCWSTR lpOperation, LPCWSTR lpFile, LPCWSTR lpParameters,LPCWSTR lpDirectory, INT nShowCmd),HINSTANCE
declare import, FindExecutableA(LPCSTR lpFile, LPCSTR lpDirectory, LPSTR lpResult),HINSTANCE
declare import, FindExecutableW(LPCWSTR lpFile, LPCWSTR lpDirectory, LPWSTR lpResult),HINSTANCE
$ifdef UNICODE
declare import, ShellExecute alias ShellExecuteW(HWND hwnd, LPCWSTR lpOperation, LPCWSTR lpFile, LPCWSTR lpParameters,LPCWSTR lpDirectory, INT nShowCmd),HINSTANCE
declare import, FindExecutable alias FindExecutableW(LPCWSTR lpFile, LPCWSTR lpDirectory, LPWSTR lpResult),HINSTANCE
$else
declare import, ShellExecute alias ShellExecuteA(HWND hwnd, LPCSTR lpOperation, LPCSTR lpFile, LPCSTR lpParameters,LPCSTR lpDirectory, INT nShowCmd),HINSTANCE
declare import, FindExecutable alias FindExecutableA(LPCSTR lpFile, LPCSTR lpDirectory, LPSTR lpResult),HINSTANCE
$endif

declare import, CommandLineToArgvW(LPCWSTR lpCmdLine, pointer pNumArgs),pointer
declare import, DuplicateIcon(HINSTANCE hInst, HICON hIcon),HICON

declare import, ShellAboutA(HWND hWnd, LPCSTR szApp, LPCSTR szOtherStuff, HICON hIcon),INT
declare import, ShellAboutW(HWND hWnd, LPCWSTR szApp, LPCWSTR szOtherStuff, HICON hIcon),INT
declare import, ExtractAssociatedIconA(HINSTANCE hInst, LPSTR lpIconPath, pointer lpiIcon),HICON
declare import, ExtractAssociatedIconW(HINSTANCE hInst, LPWSTR lpIconPath, pointer lpiIcon),HICON
declare import, ExtractAssociatedIconExA(HINSTANCE hInst,LPSTR lpIconPath, pointer lpiIconIndex, pointer lpiIconId),HICON
declare import, ExtractAssociatedIconExW(HINSTANCE hInst,LPWSTR lpIconPath, pointer lpiIconIndex, pointer lpiIconId),HICON
declare import, ExtractIconA(HINSTANCE hInst, LPCSTR lpszExeFileName, UINT nIconIndex),HICON
declare import, ExtractIconW(HINSTANCE hInst, LPCWSTR lpszExeFileName, UINT nIconIndex),HICON
$ifdef UNICODE
declare import, ShellAbout alias ShellAboutW(HWND hWnd, LPCWSTR szApp, LPCWSTR szOtherStuff, HICON hIcon),INT
declare import, ExtractAssociatedIcon alias ExtractAssociatedIconW(HINSTANCE hInst, LPWSTR lpIconPath, pointer lpiIcon),HICON
declare import, ExtractAssociatedIconEx alias ExtractAssociatedIconExW(HINSTANCE hInst,LPWSTR lpIconPath, pointer lpiIconIndex, pointer lpiIconId),HICON
declare import, ExtractIcon alias ExtractIconW(HINSTANCE hInst, LPCWSTR lpszExeFileName, UINT nIconIndex),HICON
$else
declare import, ShellAbout alias ShellAboutA(HWND hWnd, LPCSTR szApp, LPCSTR szOtherStuff, HICON hIcon),INT
declare import, ExtractAssociatedIcon alias ExtractAssociatedIconA(HINSTANCE hInst, LPSTR lpIconPath, pointer lpiIcon),HICON
declare import, ExtractAssociatedIconEx alias ExtractAssociatedIconExA(HINSTANCE hInst,LPSTR lpIconPath, pointer lpiIconIndex, pointer lpiIconId),HICON
declare import, ExtractIcon alias ExtractIconA(HINSTANCE hInst, LPCSTR lpszExeFileName, UINT nIconIndex),HICON
$endif

type DRAGINFOA,1
	UINT uSize	/* init with sizeof(DRAGINFO)*/
	POINT pt
	BOOL fNC
	LPSTR	lpFileList
	DWORD grfKeyState
endtype
type DRAGINFOW,1
	UINT uSize	/* init with sizeof(DRAGINFO)*/
	POINT pt
	BOOL fNC
	LPWSTR	lpFileList
	DWORD grfKeyState
endtype
$ifdef UNICODE
type DRAGINFO,1
	UINT uSize	/* init with sizeof(DRAGINFO)*/
	POINT pt
	BOOL fNC
	LPWSTR	lpFileList
	DWORD grfKeyState
endtype
$else
type DRAGINFO,1
	UINT uSize	/* init with sizeof(DRAGINFO)*/
	POINT pt
	BOOL fNC
	LPSTR	lpFileList
	DWORD grfKeyState
endtype
$endif

''
'' AppBar stuff
''
$define ABM_NEW	0x00000000
$define ABM_REMOVE	0x00000001
$define ABM_QUERYPOS	0x00000002
$define ABM_SETPOS	0x00000003
$define ABM_GETSTATE	0x00000004
$define ABM_GETTASKBARPOS 0x00000005
$define ABM_ACTIVATE	0x00000006	' lParam == TRUE/FALSE means activate/deactivate
$define ABM_GETAUTOHIDEBAR 0x00000007
$define ABM_SETAUTOHIDEBAR 0x00000008	' this can fail at any time.	MUST check the result
		' lParam = TRUE/FALSE	Set/Unset
		' uEdge = what edge
$define ABM_WINDOWPOSCHANGED 0x0000009

$define ABM_SETSTATE	0x0000000a

' these are put in the wparam of callback messages
$define ABN_STATECHANGE	0x0000000
$define ABN_POSCHANGED	0x0000001
$define ABN_FULLSCREENAPP	0x0000002
$define ABN_WINDOWARRANGE	0x0000003 ' lParam == TRUE means hide

' flags for get state
$define ABS_AUTOHIDE	0x0000001
$define ABS_ALWAYSONTOP 0x0000002

$define ABE_LEFT	0
$define ABE_TOP	1
$define ABE_RIGHT	2
$define ABE_BOTTOM	3

type APPBARDATA,1

	DWORD cbSize
	HWND hWnd
	UINT uCallbackMessage
	UINT uEdge
	WINRECT rc
	LPARAM lParam ' message specific
endtype

declare import, SHAppBarMessage(DWORD dwMessage, pointer pData),UINT_PTR

''
''	EndAppBar
''

'$define EIRESID(x)(-1 *(int)(x))
declare extern EIRESID(int x),int
declare import, DoEnvironmentSubstA(LPSTR szString, UINT cchString),DWORD
declare import, DoEnvironmentSubstW(LPWSTR szString, UINT cchString),DWORD
declare import, ExtractIconExA(LPCSTR lpszFile, int nIconIndex, pointer phiconLarge, pointer phiconSmall, UINT nIcons),UINT
declare import, ExtractIconExW(LPCWSTR lpszFile, int nIconIndex, pointer phiconLarge, pointer phiconSmall, UINT nIcons),UINT
$ifdef UNICODE
declare import, DoEnvironmentSubst alias DoEnvironmentSubstW(LPWSTR szString, UINT cchString),DWORD
declare import, ExtractIconEx alias ExtractIconExW(LPCWSTR lpszFile, int nIconIndex, pointer phiconLarge, pointer phiconSmall, UINT nIcons),UINT
$else
declare import, DoEnvironmentSubst alias DoEnvironmentSubstA(LPSTR szString, UINT cchString),DWORD
declare import, ExtractIconEx alias ExtractIconExA(LPCSTR lpszFile, int nIconIndex, pointer phiconLarge, pointer phiconSmall, UINT nIcons),UINT
$endif

' Shell File Operations

$define FO_MOVE	0x0001
$define FO_COPY	0x0002
$define FO_DELETE	0x0003
$define FO_RENAME	0x0004

' SHFILEOPSTRUCT.fFlags and IFileOperation::SetOperationFlags()flag values

$define FOF_MULTIDESTFILES	0x0001
$define FOF_CONFIRMMOUSE	0x0002
$define FOF_SILENT	0x0004	' don't display progress UI(confirm prompts may be displayed still)
$define FOF_RENAMEONCOLLISION	0x0008	' automatically rename the source files to avoid the collisions
$define FOF_NOCONFIRMATION	0x0010	' don't display confirmation UI, assume "yes" for cases that can be bypassed, "no" for those that can not
$define FOF_WANTMAPPINGHANDLE	0x0020	' Fill in SHFILEOPSTRUCT.hNameMappings
		' Must be freed using SHFreeNameMappings
$define FOF_ALLOWUNDO	0x0040	' enable undo including Recycle behavior for IFileOperation::Delete()
$define FOF_FILESONLY	0x0080	' only operate on the files(non folders), both files and folders are assumed without this
$define FOF_SIMPLEPROGRESS	0x0100	' means don't show names of files
$define FOF_NOCONFIRMMKDIR	0x0200	' don't dispplay confirmatino UI before making any needed directories, assume "Yes" in these cases
$define FOF_NOERRORUI	0x0400	' don't put up error UI, other UI may be displayed, progress, confirmations

$define FOF_NOCOPYSECURITYATTRIBS	0x0800	' dont copy file security attributes(ACLs)
$define FOF_NORECURSION	0x1000	' don't recurse into directories for operations that would recurse
$define FOF_NO_CONNECTED_ELEMENTS	0x2000	' don't operate on connected elements("xxx_files" folders that go with .htm files)
$define FOF_WANTNUKEWARNING	0x4000	' during delete operation, warn if nuking instead of recycling(partially overrides FOF_NOCONFIRMATION)

$define FOF_NORECURSEREPARSE	0x8000	' deprecated the operations engine always does the right thing on FolderLink objects(symlinks, reparse points, folder shortcuts)

$define FOF_NO_UI	(FOF_SILENT | FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_NOCONFIRMMKDIR)' don't display any UI at all

typedef FILEOP_FLAGS word

$define PO_DELETE	0x0013	' printer is being deleted
$define PO_RENAME	0x0014	' printer is being renamed
$define PO_PORTCHANGE	0x0020	' port this printer connected to is being changed
		' if this id is set, the strings received by
		' the copyhook are a doubly-null terminated
		' list of strings.	The first is the printer
		' name and the second is the printer port.
$define PO_REN_PORT	0x0034	' PO_RENAME and PO_PORTCHANGE at same time.

' no POF_ flags currently defined

typedef PRINTEROP_FLAGS word

' implicit parameters are:
'	if pFrom or pTo are unqualified names the current directories are
'	taken from the global current drive/directory settings managed
'	by Get/SetCurrentDrive/Directory
'	the global confirmation settings

type SHFILEOPSTRUCTA,1

	HWND	hwnd
	UINT	wFunc
	LPCSTR	pFrom
	LPCSTR	pTo
	FILEOP_FLAGS	fFlags
	BOOL	fAnyOperationsAborted
	LPVOID	hNameMappings
	LPCSTR	lpszProgressTitle ' only used if FOF_SIMPLEPROGRESS
endtype
type SHFILEOPSTRUCTW,1

	HWND	hwnd
	UINT	wFunc
	LPCWSTR	pFrom
	LPCWSTR	pTo
	FILEOP_FLAGS	fFlags
	BOOL	fAnyOperationsAborted
	LPVOID	hNameMappings
	LPCWSTR	lpszProgressTitle ' only used if FOF_SIMPLEPROGRESS
endtype
$ifdef UNICODE
type SHFILEOPSTRUCT,1

	HWND	hwnd
	UINT	wFunc
	LPCWSTR	pFrom
	LPCWSTR	pTo
	FILEOP_FLAGS	fFlags
	BOOL	fAnyOperationsAborted
	LPVOID	hNameMappings
	LPCWSTR	lpszProgressTitle ' only used if FOF_SIMPLEPROGRESS
endtype
$else
type SHFILEOPSTRUCT,1

	HWND	hwnd
	UINT	wFunc
	LPCSTR	pFrom
	LPCSTR	pTo
	FILEOP_FLAGS	fFlags
	BOOL	fAnyOperationsAborted
	LPVOID	hNameMappings
	LPCSTR	lpszProgressTitle ' only used if FOF_SIMPLEPROGRESS
endtype
$endif

declare import, SHFileOperationA(pointer lpFileOp),int
declare import, SHFileOperationW(pointer lpFileOp),int
$ifdef UNICODE
declare import, SHFileOperation alias SHFileOperationW(pointer lpFileOp),int
$else
declare import, SHFileOperation alias SHFileOperationA(pointer lpFileOp),int
$endif

declare import, SHFreeNameMappings(HANDLE hNameMappings),HRESULT

type SHNAMEMAPPINGA,1

	LPSTR	pszOldPath
	LPSTR	pszNewPath
	int	cchOldPath
	int	cchNewPath
endtype
type SHNAMEMAPPINGW,1

	LPWSTR	pszOldPath
	LPWSTR	pszNewPath
	int	cchOldPath
	int	cchNewPath
endtype
$ifdef UNICODE
type SHNAMEMAPPING,1

	LPWSTR	pszOldPath
	LPWSTR	pszNewPath
	int	cchOldPath
	int	cchNewPath
endtype
$else
type SHNAMEMAPPING,1

	LPSTR	pszOldPath
	LPSTR	pszNewPath
	int	cchOldPath
	int	cchNewPath
endtype
$endif

''
'' End Shell File Operations
''

''
''	Begin ShellExecuteEx and family
''

/* ShellExecute()and ShellExecuteEx()error codes */

/* regular WinExec()codes */
$define SE_ERR_FNF	2	' file not found
$define SE_ERR_PNF	3	' path not found
$define SE_ERR_ACCESSDENIED	5	' access denied
$define SE_ERR_OOM	8	' out of memory
$define SE_ERR_DLLNOTFOUND	32

/* error values for ShellExecute()beyond the regular WinExec()codes */
$define SE_ERR_SHARE	26
$define SE_ERR_ASSOCINCOMPLETE	27
$define SE_ERR_DDETIMEOUT	28
$define SE_ERR_DDEFAIL	29
$define SE_ERR_DDEBUSY	30
$define SE_ERR_NOASSOC	31

' Note CLASSKEY overrides CLASSNAME
$define SEE_MASK_CLASSNAME	0x00000001
$define SEE_MASK_CLASSKEY	0x00000003
' Note INVOKEIDLIST overrides IDLIST
$define SEE_MASK_IDLIST	0x00000004
$define SEE_MASK_INVOKEIDLIST	0x0000000c
$define SEE_MASK_ICON	0x00000010	'	not used
$define SEE_MASK_HOTKEY	0x00000020
$define SEE_MASK_NOCLOSEPROCESS	0x00000040
$define SEE_MASK_CONNECTNETDRV	0x00000080
$define SEE_MASK_NOASYNC	0x00000100
$define SEE_MASK_FLAG_DDEWAIT	SEE_MASK_NOASYNC ' Use SEE_MASK_NOASYNC instead of SEE_MASK_FLAG_DDEWAIT as it more accuratly describes the behavior
$define SEE_MASK_DOENVSUBST	0x00000200
$define SEE_MASK_FLAG_NO_UI	0x00000400
$define SEE_MASK_UNICODE	0x00004000
$define SEE_MASK_NO_CONSOLE	0x00008000
$define SEE_MASK_ASYNCOK	0x00100000
$define SEE_MASK_HMONITOR	0x00200000
$define SEE_MASK_NOZONECHECKS	0x00800000
$define SEE_MASK_NOQUERYCLASSSTORE 0x01000000
$define SEE_MASK_WAITFORINPUTIDLE	0x02000000
$define SEE_MASK_FLAG_LOG_USAGE	0x04000000

type SHELLEXECUTEINFOA,1
	DWORD cbSize
	ULONG fMask
	HWND hwnd
	LPCSTR	lpVerb
	LPCSTR	lpFile
	LPCSTR	lpParameters
	LPCSTR	lpDirectory
	int nShow
	HINSTANCE hInstApp
	' Optional fields
	LPVOID lpIDList
	LPCSTR	lpClass
	HKEY hkeyClass
	DWORD dwHotKey
	union
		HANDLE hIcon
		HANDLE hMonitor
	endunion
	HANDLE hProcess
endtype
type SHELLEXECUTEINFOW,1
	DWORD cbSize
	ULONG fMask
	HWND hwnd
	LPCWSTR	lpVerb
	LPCWSTR	lpFile
	LPCWSTR	lpParameters
	LPCWSTR	lpDirectory
	int nShow
	HINSTANCE hInstApp
	' Optional fields
	LPVOID lpIDList
	LPCWSTR	lpClass
	HKEY hkeyClass
	DWORD dwHotKey
	union
		HANDLE hIcon
		HANDLE hMonitor
	endunion
	HANDLE hProcess
endtype
$ifdef UNICODE
type SHELLEXECUTEINFO,1
	DWORD cbSize
	ULONG fMask
	HWND hwnd
	LPCWSTR	lpVerb
	LPCWSTR	lpFile
	LPCWSTR	lpParameters
	LPCWSTR	lpDirectory
	int nShow
	HINSTANCE hInstApp
	' Optional fields
	LPVOID lpIDList
	LPCWSTR	lpClass
	HKEY hkeyClass
	DWORD dwHotKey
	union
		HANDLE hIcon
		HANDLE hMonitor
	endunion
	HANDLE hProcess
endtype
$else
type SHELLEXECUTEINFO,1
	DWORD cbSize
	ULONG fMask
	HWND hwnd
	LPCSTR	lpVerb
	LPCSTR	lpFile
	LPCSTR	lpParameters
	LPCSTR	lpDirectory
	int nShow
	HINSTANCE hInstApp
	' Optional fields
	LPVOID lpIDList
	LPCSTR	lpClass
	HKEY hkeyClass
	DWORD dwHotKey
	union
		HANDLE hIcon
		HANDLE hMonitor
	endunion
	HANDLE hProcess
endtype
$endif

declare import, ShellExecuteExA(pointer lpExecInfo),BOOL
declare import, ShellExecuteExW(pointer lpExecInfo),BOOL
$ifdef UNICODE
declare import, ShellExecuteEx alias ShellExecuteExW(pointer lpExecInfo),BOOL
$else
declare import, ShellExecuteEx alias ShellExecuteExA(pointer lpExecInfo),BOOL
$endif

'	SHCreateProcessAsUser()
type SHCREATEPROCESSINFOW,1
	DWORD cbSize
	ULONG fMask
	HWND hwnd
	LPCWSTR	pszFile
	LPCWSTR	pszParameters
	LPCWSTR	pszCurrentDirectory
	HANDLE hUserToken
	pointer lpProcessAttributes
	pointer lpThreadAttributes
	BOOL bInheritHandles
	DWORD dwCreationFlags
	pointer lpStartupInfo
	pointer lpProcessInformation
endtype

declare import, SHCreateProcessAsUserW(pointer pscpi),BOOL

declare import, SHEvaluateSystemCommandTemplate(PCWSTR pszCmdTemplate, pointer ppszApplication,	pointer ppszCommandLine,	pointer ppszParameters),HRESULT
/*
'	SHEvaluateSystemCommandTemplate()
'	*	enforces stricter validation before calling CreateProcess().	may also be
'	used before calling ShellExecute().
'	*	should be used when caller wants the deterministic behavior from a command template
'	regardless of execution context.	it ignores the current process state,
'	such as the %PATH%, GetCurrentDirectory(), and parent process directory.
'	*	should be used when the command is hardcoded.
'	*	is used by ShellExecute()when handling file associations from HKCR.
'	*	reduces CreateProcess()commandline exploits
'	*	is not designed for processing user input, and may generate unexpected failures.
'	INPUT:
'	pszCmdTemplate =	command line, this may or may not include parameters.
'	if the parameters are substitution parameters then this API
'	should be called before parameters have been replaced.
'	(check the examples below to see sample supported inputs.)
'	OUTPUT on return: S_OK
'	ppszApplication =	verified path to the Application.	this should be passed as the lpApplication
'	parameter to CreateProcess()or the lpFile parameter to ShellExecute().
'	(allocated using CoTaskMemAlloc(), free with CoTaskMemFree())
'	ppszCommandLine =	- use if planning to call CreateProcess().
'	resulting command line template.	parameters should be replaced based on this template,
'	and then passed as the lpCommandLine parameter to CreateProcess().
'	it is guaranteed to be of a form that PathGetArgs()will always succeed correctly.
'	(allocated using CoTaskMemAlloc(), free with CoTaskMemFree())
'	ppszParameters	=	- use if planning to call ShellExecute().
'	resulting parameter list template.	parameters should be replaced based on this template,
'	and then passed as the lpParameters parameter to ShellExecute().
'	NOTE: identical to PathGetArgs(*ppszCommandLine).
'	(allocated using CoTaskMemAlloc(), free with CoTaskMemFree())
'	OUTPUT on return: FAILED()
'	all outputs will be NULL'ed on failure
'	NOTES:	the parsing logic to determine a valid Application path is non-trivial, although
'	the extension is not required and if missing will be completed
'	in the following standard order:	{ .PIF, .COM, .EXE, .BAT, .CMD }
'	Relative Paths are System Paths - if the first token has no path qualifiers
'	then the token is first checked to see if a key of the same name has
'	been installed under HKLM\Software\Microsoft\Windows\CurrentVersion\App Paths.
'	if the key or default value does not exist, it is assumed to be a child
'	of the system directories.	the following directories will be searched
'	in order for the relative token: { CSIDL_SYSTEM, CSIDL_WINDOWS }
'	Prefer Quoted Paths - if the first token in pszCmdTemplate is quoted and appears
'	to be an absolute path then the token is the only possible result.
'	Limit Forms of Unquoted Paths - if the first token is unquoted and appears
'	to be an absolute path, then it is subject to more stringent limitations.
'	if the token is a substring of CSIDL_PROGRAM_FILES or does not
'	exist on the file system, then SHEvaluateSystemCommandTemplate()will
'	attempt to complete using a token delimited by the first space of the
'	last valid path segment(usually the file name).	if this token also doesnt exist,
'	then the next space will be used, etc.
'	USAGE:	used before calling into CreateProcess()or ShellExecute(), callers
'	would typically look like the following:
$if 0 ' SAMPLE CODE
HRESULT MyCreateProcessPriv(PCWSTR pszCmd)
{
	PWSTR pszApp
	PWSTR pszCmdLine
	HRESULT hr = SHEvaluateSystemCommandTemplate(pszCmd, &pszApp, &pszCmdLine),HRESULT
	if(SUCCEEDED(hr))
{
	'	if this was a real template, maybe some kind of wnsprintf()first?
	PROCESS_INFORMATION pi
	STARTUPINFO si = {0}
	si.cb = sizeof(startup),HRESULT
	si.wShowWindow = SW_SHOWNORMAL

	if(CreateProcess(pszApp, pszCmdLine, NULL, NULL, FALSE,
		CREATE_DEFAULT_ERROR_MODE, NULL, NULL, &si, &pi))
	{
		'	we are good
		ASSERT(hr == S_OK),HRESULT
		CloseHandle(pi.hProcess),HRESULT
		CloseHandle(pi.hThread),HRESULT
	}
	else
	{
		hr = HRESULT_FROM_WIN32(GetLastError()),HRESULT
	}

	CoTaskMemFree(pszApp),HRESULT
	CoTaskMemFree(pszCmdLine),HRESULT
}
	return hr
}

HRESULT MyShellExec(PCWSTR pszCmd)
{
	PWSTR pszApp
	PWSTR pszCmdLine
	HRESULT hr = SHEvaluateSystemCommandTemplate(pszCmd, &pszApp, &pszCmdLine),HRESULT
	if(SUCCEEDED(hr))
{
	'	if this was a real template, maybe some kind of wnsprintf()first?
	SHELLEXECUTEINFOW sei = {
		sizeof(sei),	' cbSize
		0,	' fMask
		NULL,	' hwnd
		NULL,	' lpVerb
		pszApp,	' lpFile
		PathGetArgs(pszCmdLine), ' lpParameters
		NULL,	' lpDirectory
		SW_SHOWNORMAL,	' nShow
		0,	' hInstApp
		NULL,	' lpIDList
		NULL,	' lpClass
		NULL,	' hkeyClass
		0,	' dwHotKey
		NULL,	' hIcon
		NULL	' hProcess
	}

	if(ShellExecuteEx(&sei))
	{
		'	we are good
		ASSERT(hr == S_OK),HRESULT
	}
	else
	{
		hr = HRESULT_FROM_WIN32(GetLastError()),HRESULT
	}

	CoTaskMemFree(pszApp),HRESULT
	CoTaskMemFree(pszCmdLine),HRESULT
}
	return hr
}
$endif
' SAMPLE CODE
*/

/*	EXAMPLE:	Each example will show an input parameter and the results returned by
'	SHEvaluateSystemCommandTemplate().	Also included is the alternate result
'	of what CreateProcess()would have created if pszCmdTemplate were
'	passed directly as lpCommandLine and lpApplication were NULL.
'	(results marked with an asterisk(* p)indicate differences.)
'	Assume for the examples that the following paths and values exist:
'	SHGetFolderPath()values:
'	CSIDL_SYSTEM	=	C:\windows\system32
'	CSIDL_WINDOWS	=	C:\windows
'	CSIDL_PROGRAM_FILES	=	C:\Program Files
'	Environment settings
'	GetModuleFileName(NULL)=	C:\Program Files\Example\sample.exe
'	GetCurrentDirectory()	=	\\server\share\foo
'	HKLM\...\App Paths\pbrush.exe = C:\windows\system32\mspaint.exe
'	HKLM\...\App Paths\mycl.exe = C:\Program Files\Compilers\mycl.exe
'	PATH	=	c:\windows\system32C:\windowsc:\C:\Program Files\Compilers\
'	Valid Application paths:
'	C:\Program Files\Internet Explorer\iexplore.exe
'	C:\windows\system32\rundll32.exe
'	C:\windows\system32\notepad.exe
'	C:\windows\notepad.exe
'	C:\Program Files\Example\sample.exe
'	C:\Program Files\Compilers\cl.exe
'	C:\Other Programs\prog.exe
'	Suspicious(possibly hostile)Application paths:
'	C:\Program.exe
'	C:\Program Files\Internet.exe
'	C:\Program Files\Example\regedit.bat
'	C:\mycl.exe
'	\\server\share\foo\rundll32.exe
'	\\server\share\foo\myapp.exe
'	Relative Path Example $1
'	pszCmdTemplate	=	notepad.exe %1
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\windows\system32\notepad.exe
'	pszCommandLine	=	"notepad.exe" %1
'	CreateProcess()would return TRUE
'	new process =	C:\windows\system32\notepad.exe
'	Relative Path Example $2
'	pszCmdTemplate	=	rundll32.exe shell32.dll,RunDll
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\windows\system32\rundll32.exe
'	pszCommandLine	=	"rundll32.exe" shell32.dll,RunDll
'	* CreateProcess()would return TRUE
'	new process =	\\server\share\foo\rundll32.exe
'	Relative Path Example $3
'	pszCmdTemplate	=	regedit %1
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\windows\system32\regedit.exe
'	pszCommandLine	=	"regedit.exe" %1
'	* CreateProcess()would return TRUE
'	new process =	C:\Program Files\Example\regedit.bat
'	Relative Path Example $4
'	pszCmdTemplate	=	pbrush "%1"
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\windows\system32\mspaint.exe
'	pszCommandLine	=	"mspaint.exe" "%1"
'	* CreateProcess()would return FALSE
'	Relative Path Example $5
'	pszCmdTemplate	=	mycl "%1" "%2"
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Compilers\mycl.exe
'	pszCommandLine	=	"mycl.exe" "%1" "%2"
'	* CreateProcess()would return TRUE
'	new process =	C:\mycl.exe
'	Relative Path Example $6
'	pszCmdTemplate	=	myapp.exe
'	SHEvaluateSystemCommandTemplate()returns: CO_E_APPNOTFOUND
'	* CreateProcess()would return TRUE
'	new process =	\\server\share\foo\myapp.exe
'	Quoted Path Example $1
'	pszCmdTemplate	=	"C:\Program Files\Internet Explorer\iexplore.exe" -nohome
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Internet Explorer\iexplore.exe
'	pszCommandLine	=	"C:\Program Files\Internet Explorer\iexplore.exe" -nohome
'	CreateProcess()would return TRUE
'	new process =	C:\Program Files\Internet Explorer\iexplore.exe
'	Quoted Path Example $2
'	pszCmdTemplate	=	"C:\Program Files\Internet" -url
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Internet.exe
'	pszCommandLine	=	"C:\Program Files\Internet.exe" -url
'	CreateProcess()would return TRUE
'	new process =	C:\Program Files\internet.exe
'	Quoted Path Example $3
'	pszCmdTemplate	=	"C:\Program" -url
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program.exe
'	pszCommandLine	=	"C:\Program.exe" -url
'	CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $1
'	pszCmdTemplate	=	C:\Program Files\Internet Explorer\iexplore.exe -nohome
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Internet Explorer\iexplore.exe
'	pszCommandLine	=	"C:\Program Files\Internet Explorer\iexplore.exe" -nohome
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $2
'	pszCmdTemplate	=	C:\Program Files\Internet Explorer\iexplore.exe -url fool.htm
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Internet Explorer\iexplore.exe
'	pszCommandLine	=	"C:\Program Files\Internet Explorer\iexplore.exe" -url fool.htm
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $3
'	pszCmdTemplate	=	C:\Program Files\Internet Explorer\iexplore.exe -url C:\fool.htm
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Internet Explorer\iexplore.exe
'	pszCommandLine	=	"C:\Program Files\Internet Explorer\iexplore.exe" -url C:\fool.htm
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $4
'	pszCmdTemplate	=	C:\Program Files\Internet -url
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Program Files\Internet.exe
'	pszCommandLine	=	"C:\Program Files\Internet.exe" -url
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $5
'	pszCmdTemplate	=	C:\Other Programs\prog.exe -go %1 \fool %2
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Other Programs\prog.exe
'	pszCommandLine	=	"C:\Other Programs\prog.exe" %1 \fool %2
'	* CreateProcess()would return TRUE
'	new process =	C:\Other Programs\prog.exe
'	Unquoted Example $6
'	pszCmdTemplate	=	C:\Other Programs\prog.exe -go "\fool" "%1"
'	SHEvaluateSystemCommandTemplate()returns: S_OK
'	pszApplication	=	C:\Other Programs\prog.exe
'	pszCommandLine	=	"C:\Other Programs\prog.exe" -go "\fool" "%1"
'	* CreateProcess()would return TRUE
'	new process =	C:\Other Programs\prog.exe
'	Unquoted Example $7
'	pszCmdTemplate	=	C:\Program Files\Internet Explorer\iexplore.exe -url \fool.htm
'	SHEvaluateSystemCommandTemplate()returns: CO_E_APPNOTFOUND
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $8
'	pszCmdTemplate	=	C:\Program -url
'	SHEvaluateSystemCommandTemplate()returns: CO_E_APPNOTFOUND
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $9
'	pszCmdTemplate	=	C:\Other Programs\prog.exe -go \fool us
'	SHEvaluateSystemCommandTemplate()returns: CO_E_APPNOTFOUND
'	* CreateProcess()would return TRUE
'	new process =	C:\Other Programs\prog.exe
'	Unquoted Example $10
'	pszCmdTemplate	=	C:\Other Programs\prog.exe -go \fool %1
'	SHEvaluateSystemCommandTemplate()returns: CO_E_APPNOTFOUND
'	* CreateProcess()would return TRUE
'	new process =	C:\Other Programs\prog.exe
'	Unquoted Example $11
'	pszCmdTemplate	=	C:\Program "%1"
'	SHEvaluateSystemCommandTemplate()returns: E_ACCESSDENIED
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe
'	Unquoted Example $12
'	pszCmdTemplate	=	C:\Program
'	SHEvaluateSystemCommandTemplate()returns: E_ACCESSDENIED
'	* CreateProcess()would return TRUE
'	new process =	C:\Program.exe

'	used for implementing IShellFolder::GetUIObject(IID_IQueryAssociations)
'	designed for namespace extensions with registered extensible types
'	SHCreateDefaultContextMenu()and others use IQueryAssociations to build up data sets
*/
enum ASSOCCLASS
	'	which other members are used
	ASSOCCLASS_SHELL_KEY = 0 '	hkeyClass
	ASSOCCLASS_PROGID_KEY	'	hkeyClass
	ASSOCCLASS_PROGID_STR	'	pszClass(HKCR\pszClass)
	ASSOCCLASS_CLSID_KEY	'	hkeyClass
	ASSOCCLASS_CLSID_STR	'	pszClass(HKCR\CLSID\pszClass)
	ASSOCCLASS_APP_KEY	'	hkeyClass
	ASSOCCLASS_APP_STR	'	pszClass(HKCR\Applications\PathFindFileName(pszClass))
	ASSOCCLASS_SYSTEM_STR	'	pszClass
	ASSOCCLASS_FOLDER	'	none
	ASSOCCLASS_STAR	'	none
endenum
type ASSOCIATIONELEMENT,1
	ASSOCCLASS ac	' required
	HKEY hkClass	' may be NULL
	PCWSTR pszClass	' may be NULL
endtype

' the object returned from this API implements IQueryAssociations

declare import, AssocCreateForClasses(pointer rgClasses, ULONG cClasses, pointer riid, pointer ppv),HRESULT

/* $ if 0 ' SAMPLE CODE
HRESULT CCustomFolder::_AssocCreate(ITEMIDLIST* pidl, pointer riid, pointer ppv)
{
	*ppv = NULL
	ASSOCIATIONELEMENT rgAssoc[] =
{
	{ ASSOCCLASS_PROGID_STR, NULL, CCustomFolder::_MapChildToType(pidl)},
	{ ASSOCCLASS_FOLDER, NULL, NULL},
}
	if(CCustomFolder::_IsFolder(pidl))
{
	return AssocCreateForClasses(rgAssoc, ARRAYSIZE(rgAssoc), riid, ppv),HRESULT
}
	else
{
	'	skip FOLDER at the end
	return AssocCreateForClasses(rgAssoc, ARRAYSIZE(rgAssoc)-1, riid, ppv),HRESULT
}
}

HRESULT CCustomFolder::GetUIObjectOf(...)
{
	'	validate parameters
	if(riid == IID_IQueryAssociations)
{
	hr = _AssocCreate(apidl[0], riid, ppv),HRESULT
}
	'	else if ...
}
$ endif
' SAMPLE CODE
*/

''
''	End ShellExecuteEx and family
''

' RecycleBin

' struct for query recycle bin info
type SHQUERYRBINFO,1
	DWORD	cbSize
	DWORDLONG i64Size
	DWORDLONG i64NumItems
endtype

' flags for SHEmptyRecycleBin
$define SHERB_NOCONFIRMATION	0x00000001
$define SHERB_NOPROGRESSUI	0x00000002
$define SHERB_NOSOUND	0x00000004

declare import, SHQueryRecycleBinA(LPCSTR pszRootPath, pointer pSHQueryRBInfo),HRESULT
declare import, SHQueryRecycleBinW(LPCWSTR pszRootPath, pointer pSHQueryRBInfo),HRESULT
declare import, SHEmptyRecycleBinA(HWND hwnd, LPCSTR pszRootPath, DWORD dwFlags),HRESULT
declare import, SHEmptyRecycleBinW(HWND hwnd, LPCWSTR pszRootPath, DWORD dwFlags),HRESULT
$ifdef UNICODE
declare import, SHQueryRecycleBin alias SHQueryRecycleBinW(LPCWSTR pszRootPath, pointer pSHQueryRBInfo),HRESULT
declare import, SHEmptyRecycleBin alias SHEmptyRecycleBinW(HWND hwnd, LPCWSTR pszRootPath, DWORD dwFlags),HRESULT
$else
declare import, SHQueryRecycleBin alias SHQueryRecycleBinA(LPCSTR pszRootPath, pointer pSHQueryRBInfo),HRESULT
declare import, SHEmptyRecycleBin alias SHEmptyRecycleBinA(HWND hwnd, LPCSTR pszRootPath, DWORD dwFlags),HRESULT
$endif

''
'' end of RecycleBin

''
'' Taskbar notification definitions
''

enum QUERY_USER_NOTIFICATION_STATE

	QUNS_NOT_PRESENT	= 1	' The user is not present.	Heuristic check for modes like: screen saver, locked machine, non-active FUS session
	QUNS_BUSY	= 2	' The user is busy.	Heuristic check for modes like: full-screen app
	QUNS_RUNNING_D3D_FULL_SCREEN	= 3	' full-screen(exlusive-mode)D3D app
	QUNS_PRESENTATION_MODE	= 4	' Windows presentation mode(laptop feature)is turned on
	QUNS_ACCEPTS_NOTIFICATIONS	= 5	' none of the above
endenum

declare import, SHQueryUserNotificationState(pointer pquns),HRESULT

$ifdef VISTA

type NOTIFYICONDATAA,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	CHAR	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	istring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	istring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
	HICON hBalloonIcon
endtype
type NOTIFYICONDATAW,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	iwstring	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	iwstring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	iwstring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
	HICON hBalloonIcon
endtype
$ifdef UNICODE
type NOTIFYICONDATA,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	iwstring	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	iwstring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	iwstring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
	HICON hBalloonIcon
endtype
$else
type NOTIFYICONDATA,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	CHAR	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	istring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	istring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
	HICON hBalloonIcon
endtype
$endif

$else

type NOTIFYICONDATAA,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	CHAR	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	istring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	istring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
endtype
type NOTIFYICONDATAW,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	iwstring	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	iwstring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	iwstring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
endtype
$ifdef UNICODE
type NOTIFYICONDATA,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	iwstring	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	iwstring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	iwstring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
endtype
$else
type NOTIFYICONDATA,1
	DWORD cbSize
	HWND hWnd
	UINT uID
	UINT uFlags
	UINT uCallbackMessage
	HICON hIcon
	CHAR	szTip[128]
	DWORD dwState
	DWORD dwStateMask
	istring	szInfo[256]
	union
	UINT	uTimeout
	UINT	uVersion	' used with NIM_SETVERSION, values 0, 3 and 4
	endunion
	istring	szInfoTitle[64]
	DWORD dwInfoFlags
	GUID guidItem
endtype
$endif

$endif

$define NOTIFYICONDATAA_V1_SIZE	88
$define NOTIFYICONDATAW_V1_SIZE	152
$define NOTIFYICONDATAA_V2_SIZE	488
$define NOTIFYICONDATAW_V2_SIZE	936
$define NOTIFYICONDATAA_V3_SIZE	504
$define NOTIFYICONDATAW_V3_SIZE	952
$ifdef UNICODE
$define NOTIFYICONDATA_V1_SIZE	NOTIFYICONDATAW_V1_SIZE
$define NOTIFYICONDATA_V2_SIZE	NOTIFYICONDATAW_V2_SIZE
$define NOTIFYICONDATA_V3_SIZE	NOTIFYICONDATAW_V3_SIZE
$else
$define NOTIFYICONDATA_V1_SIZE	NOTIFYICONDATAA_V1_SIZE
$define NOTIFYICONDATA_V2_SIZE	NOTIFYICONDATAA_V2_SIZE
$define NOTIFYICONDATA_V3_SIZE	NOTIFYICONDATAA_V3_SIZE
$endif

$define NIN_SELECT	(WM_USER + 0)
$define NINF_KEY	0x1
$define NIN_KEYSELECT	(NIN_SELECT | NINF_KEY)

$define NIN_BALLOONSHOW	(WM_USER + 2)
$define NIN_BALLOONHIDE	(WM_USER + 3)
$define NIN_BALLOONTIMEOUT	(WM_USER + 4)
$define NIN_BALLOONUSERCLICK	(WM_USER + 5)
$define NIN_POPUPOPEN	(WM_USER + 6)
$define NIN_POPUPCLOSE	(WM_USER + 7)

$define NIM_ADD	0x00000000
$define NIM_MODIFY	0x00000001
$define NIM_DELETE	0x00000002
$define NIM_SETFOCUS	0x00000003
$define NIM_SETVERSION	0x00000004
' set NOTIFYICONDATA.uVersion with 0, 3 or 4
' please read the documentation on the behavior difference that the different versions imply
$define	NOTIFYICON_VERSION	3
$define	NOTIFYICON_VERSION_4	4

$define NIF_MESSAGE	0x00000001
$define NIF_ICON	0x00000002
$define NIF_TIP	0x00000004
$define NIF_STATE	0x00000008
$define NIF_INFO	0x00000010
$define NIF_GUID	0x00000020
$define NIF_REALTIME	0x00000040
$define NIF_SHOWTIP	0x00000080

$define NIS_HIDDEN	0x00000001
$define NIS_SHAREDICON	0x00000002

' says this is the source of a shared icon

' Notify Icon Infotip flags
$define NIIF_NONE	0x00000000
' icon flags are mutually exclusive
' and take only the lowest 2 bits
$define NIIF_INFO	0x00000001
$define NIIF_WARNING	0x00000002
$define NIIF_ERROR	0x00000003
$define NIIF_USER	0x00000004
$define NIIF_ICON_MASK	0x0000000F
$define NIIF_NOSOUND	0x00000010
$define NIIF_LARGE_ICON 0x00000020

declare import, Shell_NotifyIconA(DWORD dwMessage, pointer lpData),BOOL
declare import, Shell_NotifyIconW(DWORD dwMessage, pointer lpData),BOOL
$ifdef UNICODE
declare import, Shell_NotifyIcon alias Shell_NotifyIconW(DWORD dwMessage, pointer lpData),BOOL
$else
declare import, Shell_NotifyIcon alias Shell_NotifyIconA(DWORD dwMessage, pointer lpData),BOOL
$endif

''
'' End Taskbar Notification Icons
''

$ifndef SHFILEINFO_DEFINED
$define SHFILEINFO_DEFINED
''
'' Begin SHGetFileInfo
''

/*
 * The SHGetFileInfo API provides an easy way to get attributes
 * for a file given a pathname.
 *
 *	PARAMETERS
 *
 *	pszPath	file name to get info about
 *	dwFileAttributes	file attribs, only used with SHGFI_USEFILEATTRIBUTES
 *	psfi	place to return file info
 *	cbFileInfo	size of structure
 *	uFlags	flags
 *
 *	RETURN
 *	TRUE if things worked
 */

type SHFILEINFOA,1
	HICON	hIcon	' out: icon
	int	iIcon	' out: icon index
	DWORD	dwAttributes	' out: SFGAO_ flags
	istring	szDisplayName[MAX_PATH]	' out: display name(or path)
	istring	szTypeName[80]	' out: type name
endtype
type SHFILEINFOW,1
	HICON	hIcon	' out: icon
	int	iIcon	' out: icon index
	DWORD	dwAttributes	' out: SFGAO_ flags
	iwstring	szDisplayName[MAX_PATH]	' out: display name(or path)
	iwstring	szTypeName[80]	' out: type name
endtype
$ifdef UNICODE
type SHFILEINFO,1
	HICON	hIcon
	int	iIcon
	DWORD	dwAttributes
	iwstring	szDisplayName[MAX_PATH]
	iwstring	szTypeName[80]
endtype
$else
type SHFILEINFO,1
	HICON	hIcon
	int	iIcon
	DWORD	dwAttributes
	istring	szDisplayName[MAX_PATH]
	istring	szTypeName[80]
endtype
$endif

' NOTE: This is also in shlwapi.h.	Please keep in synch.
$endif
' !SHFILEINFO_DEFINED

$define SHGFI_ICON	0x000000100	' get icon
$define SHGFI_DISPLAYNAME	0x000000200	' get display name
$define SHGFI_TYPENAME	0x000000400	' get type name
$define SHGFI_ATTRIBUTES	0x000000800	' get attributes
$define SHGFI_ICONLOCATION	0x000001000	' get icon location
$define SHGFI_EXETYPE	0x000002000	' return exe type
$define SHGFI_SYSICONINDEX	0x000004000	' get system icon index
$define SHGFI_LINKOVERLAY	0x000008000	' put a link overlay on icon
$define SHGFI_SELECTED	0x000010000	' show icon in selected state
$define SHGFI_ATTR_SPECIFIED	0x000020000	' get only specified attributes
$define SHGFI_LARGEICON	0x000000000	' get large icon
$define SHGFI_SMALLICON	0x000000001	' get small icon
$define SHGFI_OPENICON	0x000000002	' get open icon
$define SHGFI_SHELLICONSIZE	0x000000004	' get shell size icon
$define SHGFI_PIDL	0x000000008	' pszPath is a pidl
$define SHGFI_USEFILEATTRIBUTES 0x000000010	' use passed dwFileAttribute

$define SHGFI_ADDOVERLAYS	0x000000020	' apply the appropriate overlays
$define SHGFI_OVERLAYINDEX	0x000000040	' Get the index of the overlay
		' in the upper 8 bits of the iIcon

declare import, SHGetFileInfoA(LPCSTR pszPath, DWORD dwFileAttributes, pointer psfi,UINT cbFileInfo, UINT uFlags),DWORD_PTR
declare import, SHGetFileInfoW(LPCWSTR pszPath, DWORD dwFileAttributes, pointer psfi,UINT cbFileInfo, UINT uFlags),DWORD_PTR
$ifdef UNICODE
declare import, SHGetFileInfo alias SHGetFileInfoW(LPCWSTR pszPath, DWORD dwFileAttributes, pointer psfi,UINT cbFileInfo, UINT uFlags),DWORD_PTR
$else
declare import, SHGetFileInfo alias SHGetFileInfoA(LPCSTR pszPath, DWORD dwFileAttributes, pointer psfi,UINT cbFileInfo, UINT uFlags),DWORD_PTR
$endif
' !UNICODE

type SHSTOCKICONINFO,1
	DWORD cbSize
	HICON hIcon
	int	iSysImageIndex
	int	iIcon
	iwstring szPath[MAX_PATH]
endtype

$define SHGSI_ICONLOCATION	0 ' you always get the icon location
$define SHGSI_ICON	SHGFI_ICON
$define SHGSI_SYSICONINDEX	SHGFI_SYSICONINDEX
$define SHGSI_LINKOVERLAY	SHGFI_LINKOVERLAY
$define SHGSI_SELECTED	SHGFI_SELECTED
$define SHGSI_LARGEICON	SHGFI_LARGEICON
$define SHGSI_SMALLICON	SHGFI_SMALLICON
$define SHGSI_SHELLICONSIZE	SHGFI_SHELLICONSIZE

'	Shell icons

enum SHSTOCKICONID
	SIID_DOCNOASSOC = 0	' document(blank page), no associated program
	SIID_DOCASSOC = 1	' document with an associated program
	SIID_APPLICATION = 2	' generic application with no custom icon
	SIID_FOLDER = 3	' folder(closed)
	SIID_FOLDEROPEN = 4	' folder(open)
	SIID_DRIVE525 = 5	' 5.25" floppy disk drive
	SIID_DRIVE35 = 6	' 3.5" floppy disk drive
	SIID_DRIVEREMOVE = 7	' removable drive
	SIID_DRIVEFIXED = 8	' fixed(hard disk)drive
	SIID_DRIVENET = 9	' network drive
	SIID_DRIVENETDISABLED = 10 ' disconnected network drive
	SIID_DRIVECD = 11	' CD drive
	SIID_DRIVERAM = 12	' RAM disk drive
	SIID_WORLD = 13	' entire network
	SIID_SERVER = 15	' a computer on the network
	SIID_PRINTER = 16	' printer
	SIID_MYNETWORK = 17	' My network places
	SIID_FIND = 22	' Find
	SIID_HELP = 23	' Help
	SIID_SHARE = 28	' overlay for shared items
	SIID_LINK = 29	' overlay for shortcuts to items
	SIID_SLOWFILE = 30	' overlay for slow items
	SIID_RECYCLER = 31	' empty recycle bin
	SIID_RECYCLERFULL = 32	' full recycle bin
	SIID_MEDIACDAUDIO = 40	' Audio CD Media
	SIID_LOCK = 47	' Security lock
	SIID_AUTOLIST = 49	' AutoList
	SIID_PRINTERNET = 50	' Network printer
	SIID_SERVERSHARE = 51	' Server share
	SIID_PRINTERFAX = 52	' Fax printer
	SIID_PRINTERFAXNET = 53	' Networked Fax Printer
	SIID_PRINTERFILE = 54	' Print to File
	SIID_STACK = 55	' Stack
	SIID_MEDIASVCD = 56	' SVCD Media
	SIID_STUFFEDFOLDER = 57	' Folder containing other items
	SIID_DRIVEUNKNOWN = 58	' Unknown drive
	SIID_DRIVEDVD = 59	' DVD Drive
	SIID_MEDIADVD = 60	' DVD Media
	SIID_MEDIADVDRAM = 61	' DVD-RAM Media
	SIID_MEDIADVDRW = 62	' DVD-RW Media
	SIID_MEDIADVDR = 63	' DVD-R Media
	SIID_MEDIADVDROM = 64	' DVD-ROM Media
	SIID_MEDIACDAUDIOPLUS = 65 ' CD+(Enhanced CD)Media
	SIID_MEDIACDRW = 66	' CD-RW Media
	SIID_MEDIACDR = 67	' CD-R Media
	SIID_MEDIACDBURN = 68	' Burning CD
	SIID_MEDIABLANKCD = 69	' Blank CD Media
	SIID_MEDIACDROM = 70	' CD-ROM Media
	SIID_AUDIOFILES = 71	' Audio files
	SIID_IMAGEFILES = 72	' Image files
	SIID_VIDEOFILES = 73	' Video files
	SIID_MIXEDFILES = 74	' Mixed files
	SIID_FOLDERBACK = 75	' Folder back
	SIID_FOLDERFRONT = 76	' Folder front
	SIID_SHIELD = 77	' Security shield. Use for UAC prompts only.
	SIID_WARNING = 78	' Warning
	SIID_INFO = 79	' Informational
	SIID_ERROR = 80	' Error
	SIID_KEY = 81	' Key / Secure
	SIID_SOFTWARE = 82	' Software
	SIID_RENAME = 83	' Rename
	SIID_DELETE = 84	' Delete
	SIID_MEDIAAUDIODVD = 85	' Audio DVD Media
	SIID_MEDIAMOVIEDVD = 86	' Movie DVD Media
	SIID_MEDIAENHANCEDCD = 87	' Enhanced CD Media
	SIID_MEDIAENHANCEDDVD = 88 ' Enhanced DVD Media
	SIID_MEDIAHDDVD = 89	' HD-DVD Media
	SIID_MEDIABLURAY = 90	' BluRay Media
	SIID_MEDIAVCD = 91	' VCD Media
	SIID_MEDIADVDPLUSR = 92	' DVD+R Media
	SIID_MEDIADVDPLUSRW = 93 ' DVD+RW Media
	SIID_DESKTOPPC = 94	' desktop computer
	SIID_MOBILEPC = 95	' mobile computer(laptop/notebook)
	SIID_USERS = 96	' users
	SIID_MEDIASMARTMEDIA = 97	' Smart Media
	SIID_MEDIACOMPACTFLASH = 98	' Compact Flash
	SIID_DEVICECELLPHONE = 99	' Cell phone
	SIID_DEVICECAMERA = 100	' Camera
	SIID_DEVICEVIDEOCAMERA = 101 ' Video camera
	SIID_DEVICEAUDIOPLAYER = 102 ' Audio player
	SIID_NETWORKCONNECT = 103	' Connect to network
	SIID_INTERNET = 104	' Internet
	SIID_ZIPFILE = 105	' ZIP file
	SIID_SETTINGS = 106	' Settings
	SIID_MAX_ICONS = 107
endenum

$define SIID_INVALID -1

declare import, SHGetStockIconInfo(SHSTOCKICONID siid, UINT uFlags, pointer psii),HRESULT

'$define SHGetDiskFreeSpace SHGetDiskFreeSpaceEx

declare import, SHGetDiskFreeSpaceExA(LPCSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetDiskFreeSpaceExW(LPCWSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetNewLinkInfoA(LPCSTR pszLinkTo, LPCSTR pszDir, LPSTR pszName, pointer pfMustCopy, UINT uFlags),BOOL
declare import, SHGetNewLinkInfoW(LPCWSTR pszLinkTo, LPCWSTR pszDir, LPWSTR pszName, pointer pfMustCopy, UINT uFlags),BOOL
declare import, SHGetDiskFreeSpaceA alias SHGetDiskFreeSpaceExA(LPCSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetDiskFreeSpaceW alias SHGetDiskFreeSpaceExW(LPCWSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
$ifdef UNICODE
declare import, SHGetDiskFreeSpaceEx alias SHGetDiskFreeSpaceExW(LPCWSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetDiskFreeSpace alias SHGetDiskFreeSpaceExW(LPCWSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetNewLinkInfo alias SHGetNewLinkInfoW(LPCWSTR pszLinkTo, LPCWSTR pszDir, LPWSTR pszName, pointer pfMustCopy, UINT uFlags),BOOL
$else
declare import, SHGetDiskFreeSpaceEx alias SHGetDiskFreeSpaceExA(LPCSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetDiskFreeSpace alias SHGetDiskFreeSpaceExA(LPCSTR pszDirectoryName, pointer pulFreeBytesAvailableToCaller,pointer pulTotalNumberOfBytes,	pointer pulTotalNumberOfFreeBytes),BOOL
declare import, SHGetNewLinkInfo alias SHGetNewLinkInfoA(LPCSTR pszLinkTo, LPCSTR pszDir, LPSTR pszName, pointer pfMustCopy, UINT uFlags),BOOL
$endif

$define SHGNLI_PIDL	0x000000001	' pszLinkTo is a pidl
$define SHGNLI_PREFIXNAME	0x000000002	' Make name "Shortcut to xxx"
$define SHGNLI_NOUNIQUE	0x000000004	' don't do the unique name generation
$define SHGNLI_NOLNK	0x000000008	' don't add ".lnk" extension
$define SHGNLI_NOLOCNAME	0x000000010	' use non localized(parsing)name from the target

''
'' End SHGetFileInfo
''

' Printer stuff
$define PRINTACTION_OPEN	0
$define PRINTACTION_PROPERTIES	1
$define PRINTACTION_NETINSTALL	2
$define PRINTACTION_NETINSTALLLINK 3
$define PRINTACTION_TESTPAGE	4
$define PRINTACTION_OPENNETPRN	5
$define PRINTACTION_DOCUMENTDEFAULTS 6
$define PRINTACTION_SERVERPROPERTIES 7

declare import, SHInvokePrinterCommandA(HWND hwnd, UINT uAction, LPCSTR lpBuf1, LPCSTR lpBuf2, BOOL fModal),BOOL
declare import, SHInvokePrinterCommandW(HWND hwnd, UINT uAction, LPCWSTR lpBuf1, LPCWSTR lpBuf2, BOOL fModal),BOOL
$ifdef UNICODE
declare import, SHInvokePrinterCommand alias SHInvokePrinterCommandW(HWND hwnd, UINT uAction, LPCWSTR lpBuf1, LPCWSTR lpBuf2, BOOL fModal),BOOL
$else
declare import, SHInvokePrinterCommand alias SHInvokePrinterCommandA(HWND hwnd, UINT uAction, LPCSTR lpBuf1, LPCSTR lpBuf2, BOOL fModal),BOOL
$endif

type OPEN_PRINTER_PROPS_INFOA,1
	DWORD	dwSize
	LPSTR	pszSheetName
	UINT	uSheetIndex
	DWORD	dwFlags
	BOOL	bModal
endtype
type OPEN_PRINTER_PROPS_INFOW,1
	DWORD	dwSize
	LPWSTR	pszSheetName
	UINT	uSheetIndex
	DWORD	dwFlags
	BOOL	bModal
endtype
$ifdef UNICODE
type OPEN_PRINTER_PROPS_INFO,1
	DWORD	dwSize
	LPWSTR	pszSheetName
	UINT	uSheetIndex
	DWORD	dwFlags
	BOOL	bModal
endtype
$else
type OPEN_PRINTER_PROPS_INFO,1
	DWORD	dwSize
	LPSTR	pszSheetName
	UINT	uSheetIndex
	DWORD	dwFlags
	BOOL	bModal
endtype
$endif

$define PRINT_PROP_FORCE_NAME	0x01

/*
' The SHLoadNonloadedIconOverlayIdentifiers API causes the shell's
' icon overlay manager to load any registered icon overlay
' identifers that are not currently loaded.	This is useful if an
' overlay identifier did not load at shell startup but is needed
' and can be loaded at a later time.	Identifiers already loaded
' are not affected.	Overlay identifiers implement the
' IShellIconOverlayIdentifier interface.
' Returns:
'	S_OK
*/
declare import, SHLoadNonloadedIconOverlayIdentifiers(),HRESULT

/*
' The SHIsFileAvailableOffline API determines whether a file
' or folder is available for offline use.
' Parameters:
'	pwszPath	file name to get info about
'	pdwStatus	(optional)OFFLINE_STATUS_* flags returned here
' Returns:
'	S_OK	File/directory is available offline, unless
'	OFFLINE_STATUS_INCOMPLETE is returned.
'	E_INVALIDARG	Path is invalid, or not a net path
'	E_FAIL	File/directory is not available offline
' Notes:
'	OFFLINE_STATUS_INCOMPLETE is never returned for directories.
'	Both OFFLINE_STATUS_LOCAL and OFFLINE_STATUS_REMOTE may be returned,
'	indicating "open in both places." This is common when the server is online.
*/
declare import, SHIsFileAvailableOffline(LPCWSTR pwszPath,	pointer pdwStatus),HRESULT

$define OFFLINE_STATUS_LOCAL	0x0001	' If open, it's open locally
$define OFFLINE_STATUS_REMOTE	0x0002	' If open, it's open remotely
$define OFFLINE_STATUS_INCOMPLETE	0x0004	' The local copy is currently imcomplete.
		' The file will not be available offline
		' until it has been synchronized.

'	sets the specified path to use the string resource
'	as the UI instead of the file system name
declare import, SHSetLocalizedName(LPCWSTR pszPath, LPCWSTR pszResModule, int idsRes),HRESULT

'	sets the specified path to use the string resource
'	as the UI instead of the file system name
declare import, SHRemoveLocalizedName(LPCWSTR pszPath),HRESULT
'	gets the string resource for the specified path
declare import, SHGetLocalizedName(LPCWSTR pszPath, LPWSTR pszResModule, UINT cch, pointer pidsRes),HRESULT

'====== ShellMessageBox ================================================

/* If lpcTitle is NULL, the title is taken from hWnd
' If lpcText is NULL, this is assumed to be an Out Of Memory message
' If the selector of lpcTitle or lpcText is NULL, the offset should be a
'	string resource ID
' The variable arguments must all be 32-bit values(even if fewer bits
'	are actually used)
' lpcText(or whatever string resource it causes to be loaded)should
'	be a formatting string similar to wsprintf except that only the
'	following formats are available:
'	%%	formats to a single '%'
'	%nn%s	the nn-th arg is a string which is inserted
'	%nn%ld	the nn-th arg is a DWORD, and formatted decimal
'	%nn%lx	the nn-th arg is a DWORD, and formatted hex
'	note that lengths are allowed on the %s, %ld, and %lx, just
'	like wsprintf
*/

'$define LWSTDAPIV_(type)	EXTERN_C __declspec(dllimport)type __cdecl

declare import, ShellMessageBoxA(HINSTANCE hAppInst,HWND hWnd,LPCSTR lpcText,LPCSTR lpcTitle,UINT fuStyle, ...),int
declare import, ShellMessageBoxW(HINSTANCE hAppInst,HWND hWnd,LPCWSTR lpcText,LPCWSTR lpcTitle,UINT fuStyle, ...),int
declare import, IsLFNDriveA(LPCSTR pszPath),BOOL
declare import, IsLFNDriveW(LPCWSTR pszPath),BOOL
$ifdef UNICODE
declare import, ShellMessageBox alias ShellMessageBoxW(HINSTANCE hAppInst,HWND hWnd,LPCWSTR lpcText,LPCWSTR lpcTitle,UINT fuStyle, ...),int
declare import, IsLFNDrive alias IsLFNDriveW(LPCWSTR pszPath),BOOL
$else
declare import, ShellMessageBox alias ShellMessageBoxA(HINSTANCE hAppInst,HWND hWnd,LPCSTR lpcText,LPCSTR lpcTitle,UINT fuStyle, ...),int
declare import, IsLFNDrive alias IsLFNDriveA(LPCSTR pszPath),BOOL
$endif

declare import, SHEnumerateUnreadMailAccountsA(HKEY hKeyUser, DWORD dwIndex, LPSTR pszMailAddress, int cchMailAddress),HRESULT
declare import, SHEnumerateUnreadMailAccountsW(HKEY hKeyUser, DWORD dwIndex, LPWSTR pszMailAddress, int cchMailAddress),HRESULT
declare import, SHGetUnreadMailCountA(HKEY hKeyUser, LPCSTR pszMailAddress,	pointer pdwCount,	pointer pFileTime, LPSTR pszShellExecuteCommand, int cchShellExecuteCommand),HRESULT
declare import, SHGetUnreadMailCountW(HKEY hKeyUser, LPCWSTR pszMailAddress,	pointer pdwCount,	pointer pFileTime, LPWSTR pszShellExecuteCommand, int cchShellExecuteCommand),HRESULT
declare import, SHSetUnreadMailCountA(LPCSTR pszMailAddress, DWORD dwCount, LPCSTR pszShellExecuteCommand),HRESULT
declare import, SHSetUnreadMailCountW(LPCWSTR pszMailAddress, DWORD dwCount, LPCWSTR pszShellExecuteCommand),HRESULT
$ifdef UNICODE
declare import, SHEnumerateUnreadMailAccounts alias SHEnumerateUnreadMailAccountsW(HKEY hKeyUser, DWORD dwIndex, LPWSTR pszMailAddress, int cchMailAddress),HRESULT
declare import, SHGetUnreadMailCount alias SHGetUnreadMailCountW(HKEY hKeyUser, LPCWSTR pszMailAddress,	pointer pdwCount,	pointer pFileTime, LPWSTR pszShellExecuteCommand, int cchShellExecuteCommand),HRESULT
declare import, SHSetUnreadMailCount alias SHSetUnreadMailCountW(LPCWSTR pszMailAddress, DWORD dwCount, LPCWSTR pszShellExecuteCommand),HRESULT
$else
declare import, SHEnumerateUnreadMailAccounts alias SHEnumerateUnreadMailAccountsA(HKEY hKeyUser, DWORD dwIndex, LPSTR pszMailAddress, int cchMailAddress),HRESULT
declare import, SHGetUnreadMailCount alias SHGetUnreadMailCountA(HKEY hKeyUser, LPCSTR pszMailAddress,	pointer pdwCount,	pointer pFileTime, LPSTR pszShellExecuteCommand, int cchShellExecuteCommand),HRESULT
declare import, SHSetUnreadMailCount alias SHSetUnreadMailCountA(LPCSTR pszMailAddress, DWORD dwCount, LPCSTR pszShellExecuteCommand),HRESULT
$endif

declare import, SHTestTokenMembership(HANDLE hToken, ULONG ulRID),BOOL
declare import, SHGetImageList(int iImageList, pointer riid, pointer ppvObj),HRESULT

$define SHIL_LARGE	0	' normally 32x32
$define SHIL_SMALL	1	' normally 16x16
$define SHIL_EXTRALARGE	2
$define SHIL_SYSSMALL	3	' like SHIL_SMALL, but tracks system small icon metric correctly
$define SHIL_JUMBO	4	' normally 256x256
$define SHIL_LAST	SHIL_JUMBO

' Function call types for ntshrui folder sharing helpers
typedef PFNCANSHAREFOLDERW int'HRESULT(__stdcall *PFNCANSHAREFOLDERW)(LPCWSTR pszPath),HRESULT
typedef PFNSHOWSHAREFOLDERUIW int'HRESULT(__stdcall *PFNSHOWSHAREFOLDERUIW)(HWND hwndParent, LPCWSTR pszPath),HRESULT

'$ ifndef _WIN64
'$include "poppack.inc"
'$ endif

' API for new Network Address Control

' Instantiation
$define WC_NETADDRESS L"msctls_netaddress"
declare import, InitNetworkAddressControl(),BOOL

' Address Control Messages

' NCM_GETADDRESS returns the type of address that is present in the
' control(based on TBD Net Address flags).	If the input string has
' not been validated using this message will force the validation of
' the input string.	The WPARAM is a BOOL to determine to show the
' balloon tip.	The LPARAM is a pointer to the structure to fill in
' with the address type and address string.
$define NCM_GETADDRESS(WM_USER+1)
'$define NetAddr_GetAddress(hwnd,pv)(HRESULT)SNDMSG(hwnd,NCM_GETADDRESS,0,(LPARAM)pv)
$ifdef UNICODE
declare extern NetAddr_GetAddress alias SendMessage_HLM_W(HWND hwnd, pointer pv, opt UINT uMsg=NCM_GETADDRESS),HRESULT
$else
declare extern NetAddr_GetAddress alias SendMessage_HLM_A(HWND hwnd, pointer pv, opt UINT uMsg=NCM_GETADDRESS),HRESULT
$endif
type NC_ADDRESS

	pointer pAddrInfo ' defined in iphlpapi.h
	USHORT	PortNumber
	BYTE	PrefixLength
endtype

' NCM_SETALLOWTYPE sets the type of addresses that the control will allow.
' The address flags are defined in iphlpapi.h
$define NCM_SETALLOWTYPE(WM_USER+2)
'$define NetAddr_SetAllowType(hwnd,addrMask)(HRESULT)SNDMSG(hwnd,NCM_SETALLOWTYPE,(WPARAM)addrMask,0)
$ifdef UNICODE
declare extern NetAddr_SetAllowType alias SendMessage_HWM_W(HWND hwnd, DWORD addrMask, opt UINT uMsg=NCM_SETALLOWTYPE),HRESULT
$else
declare extern NetAddr_SetAllowType alias SendMessage_HWM_A(HWND hwnd, DWORD addrMask, opt UINT uMsg=NCM_SETALLOWTYPE),HRESULT
$endif

' NCM_GETALLOWTYPE returns the currently allowed type mask.
$define NCM_GETALLOWTYPE(WM_USER+3)
'$define NetAddr_GetAllowType(hwnd)(DWORD)SNDMSG(hwnd,NCM_GETALLOWTYPE,0,0)
$ifdef UNICODE
declare extern NetAddr_GetAllowType alias SendMessage_HM_W(HWND hwnd, opt UINT uMsg=NCM_GETALLOWTYPE),DWORD
$else
declare extern NetAddr_GetAllowType alias SendMessage_HM_A(HWND hwnd, opt UINT uMsg=NCM_GETALLOWTYPE),DWORD
$endif

' NCM_DISPLAYERRORTIP displays the error balloon tip with the correct
' error string(based on the last failure from the NCM_GETADDRESS call
$define NCM_DISPLAYERRORTIP(WM_USER+4)
'$define NetAddr_DisplayErrorTip(hwnd)(HRESULT)SNDMSG(hwnd,NCM_DISPLAYERRORTIP,0,0)
$ifdef UNICODE
declare extern NetAddr_DisplayErrorTip alias SendMessage_HM_W(HWND hwnd, opt UINT uMsg=NCM_DISPLAYERRORTIP),HRESULT
$else
declare extern NetAddr_DisplayErrorTip alias SendMessage_HM_A(HWND hwnd, opt UINT uMsg=NCM_DISPLAYERRORTIP),HRESULT
$endif

' Returns the type of media(CD, DVD, Blank, etc)that is in the drive.
' dwMediaContent is set to a combination of ARCONTENT flags.
declare import, SHGetDriveMedia(LPCWSTR pszDrive, pointer pdwMediaContent),HRESULT

$endif
$endif
