$ifndef __shobjidl_inc__
$define __shobjidl_inc__

$ifndef __rpc_inc__
	$include "rpc.inc"
$endif
$ifndef __rpcndr_inc__
	$include "rpcndr.inc"
$endif

$ifndef COM_NO_WINDOWS
	$ifndef __windowssdk_inc__
		$include "windowssdk.inc"
	$endif
	$ifndef __ole2_inc__
		$include "ole2.inc"
	$endif
$endif

$ifndef __objidl_inc__
$include "objidl.inc"
$endif
$ifndef __oleidl_inc__
$include "oleidl.inc"
$endif
$ifndef __oaidl_inc__
$include "oaidl.inc"
$endif
$ifndef __shtypes_inc__
$include "shtypes.inc"
$endif
$ifndef __servprov_inc__
$include "servprov.inc"
$endif
$ifndef __comcat_inc__
$include "comcat.inc"
$endif
$ifndef __propidl_inc__
$include "propidl.inc"
$endif
$ifndef __prsht_inc__
$include "prsht.inc"
$endif
$ifndef __msxml_inc__
$include "msxml.inc"

$ifndef _WINRESRC_
$ifndef _WIN32_IE
$define _WIN32_IE 0x0501
$endif
$endif
$endif

EXTERN _IID_IPersistFolder as GUID

'MIDL_INTERFACE("000214EA-0000-0000-C000-000000000046")
interface IPersistFolder ' IPersist
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
'IPersist
	stdmethod GetClassID(pointer pClassID),HRESULT
'IPersistFolder
	stdmethod Initialize(pointer pidl),HRESULT
endinterface

EXTERN _IID_IPersistFolder2 as GUID
'MIDL_INTERFACE("1AC3D9F0-175C-11d1-95BE-00609797EA4F")
interface IPersistFolder2 ' IPersistFolder
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
'IPersist
	stdmethod GetClassID(pointer pClassID),HRESULT
'IPersistFolder
	stdmethod Initialize(pointer pidl),HRESULT
'IPersistFolder2
	stdmethod GetCurFolder(pointer ppidl),HRESULT
endinterface

EXTERN _IID_IPersistIDList as GUID
'MIDL_INTERFACE("1079acfc-29bd-11d3-8e0d-00c04f6837d5")
interface IPersistIDList ' IPersist
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetClassID(pointer pClassID),HRESULT
	stdmethod SetIDList(pointer pidl),HRESULT
	stdmethod GetIDList(/*out*/pointer ppidl),HRESULT

endinterface

EXTERN _IID_IEnumIDList as GUID
'MIDL_INTERFACE("000214F2-0000-0000-C000-000000000046")
interface IEnumIDList ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod _Next(ULONG celt, pointer rgelt, pointer pceltFetched),HRESULT
	stdmethod Skip(ULONG celt),HRESULT
	stdmethod Reset(),HRESULT
	stdmethod Clone(pointer ppenum),HRESULT

endinterface

typedef SHGDN int
typedef SHGNO int

$define SHGDN_NORMAL	0x0000	' default(display purpose)
$define SHGDN_INFOLDER	0x0001	' displayed under a folder(relative)
$define SHGDN_FOREDITING	0x1000	' for in-place editing
$define SHGDN_FORADDRESSBAR	0x4000	' UI friendly parsing name(remove ugly stuff)
$define SHGDN_FORPARSING	0x8000	' parsing name for ParseDisplayName()
typedef SHGDNF DWORD

typedef SHCONF int
$define SHCONTF_FOLDERS	0x0020	' only want folders enumerated(SFGAO_FOLDER)
$define SHCONTF_NONFOLDERS	0x0040	' include non folders
$define SHCONTF_INCLUDEHIDDEN	0x0080	' show items normally hidden
$define SHCONTF_INIT_ON_FIRST_NEXT	0x0100	' allow EnumObject()to return before validating enum
$define SHCONTF_NETPRINTERSRCH	0x0200	' hint that client is looking for printers
$define SHCONTF_SHAREABLE	0x0400	' hint that client is looking sharable resources(remote shares)
$define SHCONTF_STORAGE	0x0800	' include all items with accessible storage and their ancestors

typedef SHCONTF DWORD

$define SHCIDS_ALLFIELDS	0x80000000
$define SHCIDS_CANONICALONLY	0x10000000
$define SHCIDS_BITMASK	0xFFFF0000
$define SHCIDS_COLUMNMASK	0x0000FFFF
$define SFGAO_CANCOPY	DROPEFFECT_COPY ' Objects can be copied	(0x1)
$define SFGAO_CANMOVE	DROPEFFECT_MOVE ' Objects can be moved	(0x2)
$define SFGAO_CANLINK	DROPEFFECT_LINK ' Objects can be linked	(0x4)
$define SFGAO_STORAGE	0x00000008	' supports BindToObject(IID_IStorage)
$define SFGAO_CANRENAME	0x00000010	' Objects can be renamed
$define SFGAO_CANDELETE	0x00000020	' Objects can be deleted
$define SFGAO_HASPROPSHEET	0x00000040	' Objects have property sheets
$define SFGAO_DROPTARGET	0x00000100	' Objects are drop target
$define SFGAO_CAPABILITYMASK	0x00000177
$define SFGAO_ENCRYPTED	0x00002000	' object is encrypted(use alt color)
$define SFGAO_ISSLOW	0x00004000	' 'slow' object
$define SFGAO_GHOSTED	0x00008000	' ghosted icon
$define SFGAO_LINK	0x00010000	' Shortcut(link)
$define SFGAO_SHARE	0x00020000	' shared
$define SFGAO_READONLY	0x00040000	' read-only
$define SFGAO_HIDDEN	0x00080000	' hidden object
$define SFGAO_DISPLAYATTRMASK	0x000FC000
$define SFGAO_FILESYSANCESTOR	0x10000000	' may contain children with SFGAO_FILESYSTEM
$define SFGAO_FOLDER	0x20000000	' support BindToObject(IID_IShellFolder)
$define SFGAO_FILESYSTEM	0x40000000	' is a win32 file system object(file/folder/root)
$define SFGAO_HASSUBFOLDER	0x80000000	' may contain children with SFGAO_FOLDER
$define SFGAO_CONTENTSMASK	0x80000000
$define SFGAO_VALIDATE	0x01000000	' invalidate cached information
$define SFGAO_REMOVABLE	0x02000000	' is this removeable media?
$define SFGAO_COMPRESSED	0x04000000	' Object is compressed(use alt color)
$define SFGAO_BROWSABLE	0x08000000	' supports IShellFolder, but only implements CreateViewObject()(non-folder view)
$define SFGAO_NONENUMERATED	0x00100000	' is a non-enumerated object
$define SFGAO_NEWCONTENT	0x00200000	' should show bold in explorer tree
$define SFGAO_CANMONIKER	0x00400000	' defunct
$define SFGAO_HASSTORAGE	0x00400000	' defunct
$define SFGAO_STREAM	0x00400000	' supports BindToObject(IID_IStream)
$define SFGAO_STORAGEANCESTOR	0x00800000	' may contain children with SFGAO_STORAGE or SFGAO_STREAM
$define SFGAO_STORAGECAPMASK	0x70C50008	' for determining storage capabilities, ie for open/save semantics
typedef SFGAOF ULONG

$define STR_SKIP_BINDING_CLSID						L"Skip Binding CLSID"
$define STR_PARSE_PREFER_FOLDER_BROWSING			L"Parse Prefer Folder Browsing"
$define STR_DONT_PARSE_RELATIVE						L"Don't Parse Relative"
$define STR_PARSE_TRANSLATE_ALIASES					L"Parse Translate Aliases"
$define STR_PARSE_SHELL_PROTOCOL_TO_FILE_OBJECTS	L"Parse Shell Protocol To File Objects"

EXTERN _IID_IShellFolder as GUID

'MIDL_INTERFACE("000214E6-0000-0000-C000-000000000046")
interface IShellFolder ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod ParseDisplayName(HWND hwnd,IBindCtx pbc,/* [in] */ LPOLESTR pszDisplayName,/*out*/pointer pchEaten,/*out*/pointer ppidl,/*out in*/pointer pdwAttributes),HRESULT
	stdmethod EnumObjects(HWND hwnd,SHCONTF grfFlags,/*out*/pointer ppenumIDList),HRESULT
	stdmethod BindToObject(pointer pidl,IBindCtx pbc,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod BindToStorage(pointer pidl,IBindCtx pbc,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod CompareIDs(LPARAM lParam,pointer pidl1,pointer pidl2),HRESULT
	stdmethod CreateViewObject(HWND hwndOwner,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod GetAttributesOf(UINT cidl,pointer apidl,/*out in*/pointer rgfInOut),HRESULT
	stdmethod GetUIObjectOf(HWND hwndOwner,UINT cidl,pointer apidl,pointer riid,/*out in*/pointer rgfReserved,/*out*/pointer ppv),HRESULT
	stdmethod GetDisplayNameOf(pointer pidl,SHGDNF uFlags,/*out*/pointer pName),HRESULT
	stdmethod SetNameOf(HWND hwnd,pointer pidl,/* [in] */ LPCOLESTR pszName,SHGDNF uFlags,/*out*/pointer ppidlOut),HRESULT

endinterface

type EXTRASEARCH
	GUID guidSearch
	iwstring wszFriendlyName[ 80 ]
	iwstring wszUrl[ 2084 ]
endtype

EXTERN _IID_IEnumExtraSearch as GUID

'MIDL_INTERFACE("0E700BE1-9DB6-11d1-A1CE-00C04FD75D13")
interface IEnumExtraSearch ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod _Next(ULONG celt,pointer rgelt,/*out*/pointer pceltFetched),HRESULT
	stdmethod Skip(ULONG celt),HRESULT
	stdmethod Reset(),HRESULT
	stdmethod Clone(/*out*/pointer ppenum),HRESULT

endinterface

typedef SHCOLSTATE int
const SHCOLSTATE_TYPE_STR	= 0x1
const SHCOLSTATE_TYPE_INT	= 0x2
const SHCOLSTATE_TYPE_DATE	= 0x3
const SHCOLSTATE_TYPEMASK	= 0xf
const SHCOLSTATE_ONBYDEFAULT	= 0x10
const SHCOLSTATE_SLOW	= 0x20
const SHCOLSTATE_EXTENDED	= 0x40
const SHCOLSTATE_SECONDARYUI	= 0x80
const SHCOLSTATE_HIDDEN	= 0x100
const SHCOLSTATE_PREFER_VARCMP	= 0x200

typedef SHCOLSTATEF UINT

type SHCOLUMNID
	GUID fmtid
	DWORD pid
endtype

EXTERN _IID_IShellFolder2 as GUID

'MIDL_INTERFACE("93F2F68C-1D1B-11d3-A30E-00C04F79ABD1")
interface IShellFolder2 ' IShellFolder
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod ParseDisplayName(HWND hwnd,pointer pbc,/* [in] */ LPOLESTR pszDisplayName,/*out*/pointer pchEaten,/*out*/pointer ppidl,/*out in*/pointer pdwAttributes),HRESULT
	stdmethod EnumObjects(HWND hwnd,SHCONTF grfFlags,/*out*/pointer ppenumIDList),HRESULT
	stdmethod BindToObject(pointer pidl,pointer pbc,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod BindToStorage(pointer pidl,pointer pbc,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod CompareIDs(LPARAM lParam,pointer pidl1,pointer pidl2),HRESULT
	stdmethod CreateViewObject(HWND hwndOwner,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod GetAttributesOf(UINT cidl,pointer apidl,/*out in*/pointer rgfInOut),HRESULT
	stdmethod GetUIObjectOf(HWND hwndOwner,UINT cidl,pointer apidl,pointer riid,/*out in*/pointer rgfReserved,/*out*/pointer ppv),HRESULT
	stdmethod GetDisplayNameOf(pointer pidl,SHGDNF uFlags,/*out*/pointer pName),HRESULT
	stdmethod SetNameOf(HWND hwnd,pointer pidl,/* [in] */ LPCOLESTR pszName,SHGDNF uFlags,/*out*/pointer ppidlOut),HRESULT
'IShellFolder2
	stdmethod GetDefaultSearchGUID(/*out*/pointer pguid),HRESULT
	stdmethod EnumSearches(/*out*/pointer ppenum),HRESULT
	stdmethod GetDefaultColumn(DWORD dwRes,/*out*/pointer pSort,/*out*/pointer pDisplay),HRESULT
	stdmethod GetDefaultColumnState(UINT iColumn,/*out*/pointer pcsFlags),HRESULT
	stdmethod GetDetailsEx(pointer pidl,pointer pscid,/*out*/pointer pv),HRESULT
	stdmethod GetDetailsOf(pointer pidl,UINT iColumn,/*out*/pointer psd),HRESULT
	stdmethod MapColumnToSCID(UINT iColumn,pointer pscid),HRESULT

endinterface

typedef LPVIEWSETTINGS pointer

typedef FOLDERFLAGS int
$define FWF_AUTOARRANGE 0x1
$define FWF_ABBREVIATEDNAMES 0x2
$define FWF_SNAPTOGRID 0x4
$define FWF_OWNERDATA 0x8
$define FWF_BESTFITWINDOW 0x10
$define FWF_DESKTOP 0x20
$define FWF_SINGLESEL 0x40
$define FWF_NOSUBFOLDERS 0x80
$define FWF_TRANSPARENT 0x100
$define FWF_NOCLIENTEDGE 0x200
$define FWF_NOSCROLL 0x400
$define FWF_ALIGNLEFT 0x800
$define FWF_NOICONS 0x1000
$define FWF_SHOWSELALWAYS 0x2000
$define FWF_NOVISIBLE 0x4000
$define FWF_SINGLECLICKACTIVATE 0x8000
$define FWF_NOWEBVIEW 0x10000
$define FWF_HIDEFILENAMES 0x20000
$define FWF_CHECKSELECT 0x40000

typedef FOLDERVIEWMODE int
$define FVM_FIRST 1
$define FVM_ICON 1
$define FVM_SMALLICON 2
$define FVM_LIST 3
$define FVM_DETAILS 4
$define FVM_THUMBNAIL 5
$define FVM_TILE 6
$define FVM_THUMBSTRIP 7
$define FVM_LAST 7

type FOLDERSETTINGS
	UINT ViewMode
	UINT fFlags
endtype

typedef SVSIF UINT
$define SVSI_DESELECT	0x00000000
$define SVSI_SELECT	0x00000001
$define SVSI_EDIT	0x00000003	' includes select
$define SVSI_DESELECTOTHERS 0x00000004
$define SVSI_ENSUREVISIBLE	0x00000008
$define SVSI_FOCUSED	0x00000010
$define SVSI_TRANSLATEPT	0x00000020
$define SVSI_SELECTIONMARK	0x00000040
$define SVSI_POSITIONITEM	0x00000080
$define SVSI_CHECK	0x00000100
$define SVSI_NOSTATECHANGE	0x80000000

typedef SVGIO int
$define SVGIO_BACKGROUND 0
$define SVGIO_SELECTION 0x1
$define SVGIO_ALLVIEW 0x2
$define SVGIO_CHECKED 0x3
$define SVGIO_TYPE_MASK 0xf
$define SVGIO_FLAG_VIEWORDER 0x80000000

typedef SVUIA_STATUS int
$define SVUIA_DEACTIVATE 0
$define SVUIA_ACTIVATE_NOFOCUS 1
$define SVUIA_ACTIVATE_FOCUS 2
$define SVUIA_INPLACEACTIVATE 3

$ifdef _FIX_ENABLEMODELESS_CONFLICT
$define	EnableModeless EnableModelessSV
$endif

$ifdef _NEVER_
typedef LPFNSVADDPROPSHEETPAGE LPARAM
$else
	$ifndef __prsht_inc__
	$include "prsht.inc"
	$endif
typedef LPFNSVADDPROPSHEETPAGE LPFNADDPROPSHEETPAGE
$endif

EXTERN _IID_IShellView as GUID

'MIDL_INTERFACE("000214E3-0000-0000-C000-000000000046")
interface IShellView ' IOleWindow
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod TranslateAccelerator(pointer pmsg),HRESULT
	stdmethod EnableModeless(BOOL fEnable),HRESULT
	stdmethod UIActivate(UINT uState),HRESULT
	stdmethod Refresh(),HRESULT
	stdmethod CreateViewWindow(comref psvPrevious,pointer pfs,comref psb,/*out*/pointer prcView,/*out*/pointer phWnd),HRESULT
	stdmethod DestroyViewWindow(),HRESULT
	stdmethod GetCurrentInfo(/*out*/pointer pfs),HRESULT
	stdmethod AddPropertySheetPages(DWORD dwReserved,LPFNSVADDPROPSHEETPAGE pfn,LPARAM lparam),HRESULT
	stdmethod SaveViewState(),HRESULT
	stdmethod SelectItem(pointer pidlItem,SVSIF uFlags),HRESULT
	stdmethod GetItemObject(UINT uItem,pointer riid,/*out*/pointer ppv),HRESULT

endinterface

type SHELLVIEWID
	UINT	Data1
	USHORT Data2
	USHORT Data3
	UCHAR Data4[ 8 ]
endtype

$define SV2GV_CURRENTVIEW -1
$define SV2GV_DEFAULTVIEW -2

EXTERN _IID_IShellBrowser as GUID

'MIDL_INTERFACE("000214E2-0000-0000-C000-000000000046")
interface IShellBrowser ' IOleWindow
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod InsertMenusSB(HMENU hmenuShared,/*out in*/pointer lpMenuWidths),HRESULT
	stdmethod SetMenuSB(HMENU hmenuShared,HOLEMENU holemenuRes,HWND hwndActiveObject),HRESULT
	stdmethod RemoveMenusSB(HMENU hmenuShared),HRESULT
	stdmethod SetStatusTextSB(LPCOLESTR pszStatusText),HRESULT
	stdmethod EnableModelessSB(BOOL fEnable),HRESULT
	stdmethod TranslateAcceleratorSB(pointer pmsg,USHORT wID),HRESULT
	stdmethod BrowseObject(pointer pidl,UINT wFlags),HRESULT
	stdmethod GetViewStateStream(DWORD grfMode,/*out*/pointer ppStrm),HRESULT
	stdmethod GetControlWindow(UINT id,/*out*/pointer phwnd),HRESULT
	stdmethod SendControlMsg(UINT id,UINT uMsg,WPARAM wParam,LPARAM lParam,pointer pret),HRESULT
	stdmethod QueryActiveShellView(/*out*/pointer ppshv),HRESULT
	stdmethod OnViewWindowActive(IShellView pshv),HRESULT
	stdmethod SetToolbarItems(pointer lpButtons,UINT nButtons,UINT uFlags),HRESULT
endinterface

'$include <pshpack8.h>
type SV2CVW2_PARAMS
	DWORD cbSize
	IShellView psvPrev
	pointer pfs
	IShellBrowser psbOwner
	pointer prcView
	pointer pvid
	HWND hwndView
endtype

'$include <poppack.h>

EXTERN _IID_IShellView2 as GUID

'MIDL_INTERFACE("88E39E80-3578-11CF-AE69-08002B2E1262")
interface IShellView2 ' IShellView
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod TranslateAccelerator(pointer pmsg),HRESULT
	stdmethod EnableModeless(BOOL fEnable),HRESULT
	stdmethod UIActivate(UINT uState),HRESULT
	stdmethod Refresh(),HRESULT
	stdmethod CreateViewWindow(pointer psvPrevious,pointer pfs,pointer psb,/*out*/pointer prcView,/*out*/pointer phWnd),HRESULT
	stdmethod DestroyViewWindow(),HRESULT
	stdmethod GetCurrentInfo(/*out*/pointer pfs),HRESULT
	stdmethod AddPropertySheetPages(DWORD dwReserved,LPFNSVADDPROPSHEETPAGE pfn,LPARAM lparam),HRESULT
	stdmethod SaveViewState(),HRESULT
	stdmethod SelectItem(pointer pidlItem,SVSIF uFlags),HRESULT
	stdmethod GetItemObject(UINT uItem,pointer riid,/*out*/pointer ppv),HRESULT

'IShellView2
	stdmethod GetView(/*out in*/pointer pvid,ULONG uView),HRESULT
	stdmethod CreateViewWindow2(pointer lpParams),HRESULT
	stdmethod HandleRename(pointer pidlNew),HRESULT
	stdmethod SelectAndPositionItem(pointer pidlItem,UINT uFlags,pointer ppt),HRESULT

endinterface

EXTERN _IID_IFolderView as GUID

'MIDL_INTERFACE("cde725b0-ccc9-4519-917e-325d72fab4ce")
interface IFolderView ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
/*removed {*/
	stdmethod GetCurrentViewMode(/*out in*/pointer pViewMode),HRESULT
	stdmethod SetCurrentViewMode(UINT ViewMode),HRESULT
	stdmethod GetFolder(pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod Item(int iItemIndex,/*out*/pointer ppidl),HRESULT
	stdmethod ItemCount(UINT uFlags,/*out*/pointer pcItems),HRESULT
	stdmethod Items(UINT uFlags,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod GetSelectionMarkedItem(/*out*/pointer piItem),HRESULT
	stdmethod GetFocusedItem(/*out*/pointer piItem),HRESULT
	stdmethod GetItemPosition(pointer pidl,/*out*/pointer ppt),HRESULT
	stdmethod GetSpacing(/* [full][out][in] */ pointer ppt),HRESULT
	stdmethod GetDefaultSpacing(/*out*/pointer ppt),HRESULT
	stdmethod GetAutoArrange(),HRESULT
	stdmethod SelectItem(int iItem,DWORD dwFlags),HRESULT
	stdmethod SelectAndPositionItems(UINT cidl,pointer apidl,/* [size_is][full][in] */ pointer apt,DWORD dwFlags),HRESULT

endinterface

'$define SID_SFolderView IID_IFolderView	' folder view, usuaally IFolderView
$ifdef _FIX_ENABLEMODELESS_CONFLICT
#undef	EnableModeless
$endif

EXTERN _IID_IFolderFilterSite as GUID

'MIDL_INTERFACE("C0A651F5-B48B-11d2-B5ED-006097C686F6")
interface IFolderFilterSite ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetFilter(pointer punk),HRESULT

endinterface

EXTERN _IID_IFolderFilter as GUID

'MIDL_INTERFACE("9CC22886-DC8E-11d2-B1D0-00C04F8EEB3E")
interface IFolderFilter ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod ShouldShow(IShellFolder psf,pointer pidlFolder,pointer pidlItem),HRESULT
	stdmethod GetEnumFlags(IShellFolder psf,pointer pidlFolder,pointer phwnd,/*out*/pointer pgrfFlags),HRESULT

endinterface

$define SBSP_DEFBROWSER 0x0000
$define SBSP_SAMEBROWSER	0x0001
$define SBSP_NEWBROWSER	0x0002
$define SBSP_DEFMODE	0x0000
$define SBSP_OPENMODE	0x0010
$define SBSP_EXPLOREMODE	0x0020
$define SBSP_HELPMODE	0x0040 ' IEUNIX : Help window uses this.
$define SBSP_NOTRANSFERHIST	0x0080
$define SBSP_ABSOLUTE	0x0000
$define SBSP_RELATIVE	0x1000
$define SBSP_PARENT	0x2000
$define SBSP_NAVIGATEBACK	0x4000
$define SBSP_NAVIGATEFORWARD	0x8000
$define SBSP_ALLOW_AUTONAVIGATE 0x10000
$define SBSP_CALLERUNTRUSTED	0x00800000
$define SBSP_TRUSTFIRSTDOWNLOAD	0x01000000
$define SBSP_UNTRUSTEDFORDOWNLOAD 0x02000000
$define SBSP_NOAUTOSELECT	0x04000000
$define SBSP_WRITENOHISTORY	0x08000000
$define SBSP_TRUSTEDFORACTIVEX	0x10000000
$define SBSP_REDIRECT	0x40000000
$define SBSP_INITIATEDBYHLINKFRAME	0x80000000
$define FCW_STATUS	0x0001
$define FCW_TOOLBAR	0x0002
$define FCW_TREE	0x0003
$define FCW_INTERNETBAR 0x0006
$define FCW_PROGRESS	0x0008
$define FCT_MERGE	0x0001
$define FCT_CONFIGABLE	0x0002
$define FCT_ADDTOEND	0x0004

$ifdef _NEVER_
typedef LPTBBUTTONSB LPARAM
$else
	$ifndef __commctrl_inc__
	$include "commctrl.inc"
	$endif
typedef LPTBBUTTONSB pointer
$endif


EXTERN _IID_IProfferService as GUID

'MIDL_INTERFACE("cb728b20-f786-11ce-92ad-00aa00a74cd0")
interface IProfferService ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod ProfferService(pointer rguidService,IServiceProvider psp,/*out*/pointer pdwCookie),HRESULT
	stdmethod RevokeService(DWORD dwCookie),HRESULT

endinterface

'$define SID_SProfferService IID_IProfferService	' nearest service that you can proffer to
typedef PROPERTYUI_NAME_FLAGS int
$define PUIFNF_DEFAULT 0
$define PUIFNF_MNEMONIC 0x1

typedef PROPERTYUI_FLAGS int
$define PUIF_DEFAULT 0
$define PUIF_RIGHTALIGN 0x1
$define PUIF_NOLABELININFOTIP 0x2

typedef PROPERTYUI_FORMAT_FLAGS int
$define PUIFFDF_DEFAULT 0
$define PUIFFDF_RIGHTTOLEFT 0x1
$define PUIFFDF_SHORTFORMAT 0x2
$define PUIFFDF_NOTIME 0x4
$define PUIFFDF_FRIENDLYDATE 0x8
$define PUIFFDF_NOUNITS 0x10

EXTERN _IID_IPropertyUI as GUID
'MIDL_INTERFACE("757a7d9f-919a-4118-99d7-dbb208c8cc66")
interface IPropertyUI ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod ParsePropertyName(LPCWSTR pszName,/*out*/pointer pfmtid,/*out*/pointer ppid,/*out in*/pointer pchEaten),HRESULT
	stdmethod GetCannonicalName(pointer fmtid,PROPID pid,LPWSTR pwszText,DWORD cchText),HRESULT
	stdmethod GetDisplayName(pointer fmtid,PROPID pid,PROPERTYUI_NAME_FLAGS flags,LPWSTR pwszText,DWORD cchText),HRESULT
	stdmethod GetPropertyDescription(pointer fmtid,PROPID pid,LPWSTR pwszText,DWORD cchText),HRESULT
	stdmethod GetDefaultWidth(pointer fmtid,PROPID pid,/*out*/pointer pcxChars),HRESULT
	stdmethod GetFlags(pointer fmtid,PROPID pid,/*out*/pointer pFlags),HRESULT
	stdmethod FormatForDisplay(pointer fmtid,PROPID pid,pointer pvar,PROPERTYUI_FORMAT_FLAGS flags,LPWSTR pwszText,DWORD cchText),HRESULT
	stdmethod GetHelpInfo(pointer fmtid,PROPID pid,LPWSTR pwszHelpFile,DWORD cch,/*out*/pointer puHelpID),HRESULT

endinterface

EXTERN _IID_ICategoryProvider as GUID

'MIDL_INTERFACE("9af64809-5864-4c26-a720-c1f78c086ee3")
interface ICategoryProvider ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod CanCategorizeOnSCID(pointer pscid),HRESULT
	stdmethod GetDefaultCategory(pointer pguid,pointer pscid),HRESULT
	stdmethod GetCategoryForSCID(pointer pscid,pointer pguid),HRESULT
	stdmethod EnumCategories(pointer penum),HRESULT
	stdmethod GetCategoryName(pointer pguid,LPWSTR pszName,UINT cch),HRESULT
	stdmethod CreateCategory(pointer pguid,REFIID riid,/* pointer */ pointer ppv),HRESULT

endinterface

typedef CATEGORYINFO_FLAGS int
$define CATINFO_NORMAL 0
$define CATINFO_COLLAPSED 0x1
$define CATINFO_HIDDEN 0x2

typedef CATSORT_FLAGS int
$define CATSORT_DEFAULT 0
$define CATSORT_NAME 0x1

type CATEGORY_INFO
	CATEGORYINFO_FLAGS cif
	iwstring wszName[ 260 ]
endtype

EXTERN _IID_ICategorizer as GUID

'MIDL_INTERFACE("a3b14589-9174-49a8-89a3-06a1ae2b9ba7")
interface ICategorizer ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetDescription(LPWSTR pszDesc,UINT cch),HRESULT
	stdmethod GetCategory(UINT cidl,pointer apidl,/* [size_is][out][in] */ pointer rgCategoryIds),HRESULT
	stdmethod GetCategoryInfo(DWORD dwCategoryId,pointer pci),HRESULT
	stdmethod CompareCategory(CATSORT_FLAGS csfFlags,DWORD dwCategoryId1,DWORD dwCategoryId2),HRESULT

endinterface

typedef SLR_FLAGS int
$define SLR_NO_UI 0x1
$define SLR_ANY_MATCH 0x2
$define SLR_UPDATE 0x4
$define SLR_NOUPDATE 0x8
$define SLR_NOSEARCH 0x10
$define SLR_NOTRACK 0x20
$define SLR_NOLINKINFO 0x40
$define SLR_INVOKE_MSI 0x80
$define SLR_NO_UI_WITH_MSG_PUMP 0x101

typedef SLGP_FLAGS int
$define SLGP_SHORTPATH 0x1
$define SLGP_UNCPRIORITY 0x2
$define SLGP_RAWPATH 0x4

EXTERN _IID_IShellLinkA as GUID

'MIDL_INTERFACE("000214EE-0000-0000-C000-000000000046")
interface IShellLinkA ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetPath(LPSTR pszFile,int cch,/* [full][out][in] */ pointer pfd,DWORD fFlags),HRESULT
	stdmethod GetIDList(/*out*/pointer ppidl),HRESULT
	stdmethod SetIDList(pointer pidl),HRESULT
	stdmethod GetDescription(LPSTR pszName,int cch),HRESULT
	stdmethod SetDescription(LPCSTR pszName),HRESULT
	stdmethod GetWorkingDirectory(LPSTR pszDir,int cch),HRESULT
	stdmethod SetWorkingDirectory(LPCSTR pszDir),HRESULT
	stdmethod GetArguments(LPSTR pszArgs,int cch),HRESULT
	stdmethod SetArguments(LPCSTR pszArgs),HRESULT
	stdmethod GetHotkey(/*out*/pointer pwHotkey),HRESULT
	stdmethod SetHotkey(USHORT wHotkey),HRESULT
	stdmethod GetShowCmd(/*out*/pointer piShowCmd),HRESULT
	stdmethod SetShowCmd(int iShowCmd),HRESULT
	stdmethod GetIconLocation(LPSTR pszIconPath,int cch,/*out*/pointer piIcon),HRESULT
	stdmethod SetIconLocation(LPCSTR pszIconPath,int iIcon),HRESULT
	stdmethod SetRelativePath(LPCSTR pszPathRel,DWORD dwReserved),HRESULT
	stdmethod Resolve(HWND hwnd,DWORD fFlags),HRESULT
	stdmethod SetPath(LPCSTR pszFile),HRESULT

endinterface

EXTERN _IID_IShellLinkW as GUID

'MIDL_INTERFACE("000214F9-0000-0000-C000-000000000046")
interface IShellLinkW ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetPath(LPWSTR pszFile,int cch,/* [full][out][in] */ pointer pfd,DWORD fFlags),HRESULT
	stdmethod GetIDList(/*out*/pointer ppidl),HRESULT
	stdmethod SetIDList(pointer pidl),HRESULT
	stdmethod GetDescription(LPWSTR pszName,Int cch),HRESULT
	stdmethod SetDescription(LPCWSTR pszName),HRESULT
	stdmethod GetWorkingDirectory(LPWSTR pszDir,Int cch),HRESULT
	stdmethod SetWorkingDirectory(LPCWSTR pszDir),HRESULT
	stdmethod GetArguments(LPWSTR pszArgs,Int cch),HRESULT
	stdmethod SetArguments(LPCWSTR pszArgs),HRESULT
	stdmethod GetHotkey(/*out*/pointer pwHotkey),HRESULT
	stdmethod SetHotkey(USHORT wHotkey),HRESULT
	stdmethod GetShowCmd(/*out*/pointer piShowCmd),HRESULT
	stdmethod SetShowCmd(int iShowCmd),HRESULT
	stdmethod GetIconLocation(LPWSTR pszIconPath,int cch,/*out*/pointer piIcon),HRESULT
	stdmethod SetIconLocation(LPCWSTR pszIconPath,int iIcon),HRESULT
	stdmethod SetRelativePath(LPCWSTR pszPathRel,DWORD dwReserved),HRESULT
	stdmethod Resolve(HWND hwnd,DWORD fFlags),HRESULT
	stdmethod SetPath(LPCWSTR pszFile),HRESULT

endinterface

$ifdef UNICODE
interface IShellLink ' IShellLinkW
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetPath(LPWSTR pszFile,int cch,pointer pfd,DWORD fFlags),HRESULT
	stdmethod GetIDList(pointer ppidl),HRESULT
	stdmethod SetIDList(pointer pidl),HRESULT
	stdmethod GetDescription(LPWSTR pszName,Int cch),HRESULT
	stdmethod SetDescription(LPCWSTR pszName),HRESULT
	stdmethod GetWorkingDirectory(LPWSTR pszDir,Int cch),HRESULT
	stdmethod SetWorkingDirectory(LPCWSTR pszDir),HRESULT
	stdmethod GetArguments(LPWSTR pszArgs,Int cch),HRESULT
	stdmethod SetArguments(LPCWSTR pszArgs),HRESULT
	stdmethod GetHotkey(pointer pwHotkey),HRESULT
	stdmethod SetHotkey(USHORT wHotkey),HRESULT
	stdmethod GetShowCmd(pointer piShowCmd),HRESULT
	stdmethod SetShowCmd(int iShowCmd),HRESULT
	stdmethod GetIconLocation(LPWSTR pszIconPath,int cch,pointer piIcon),HRESULT
	stdmethod SetIconLocation(LPCWSTR pszIconPath,int iIcon),HRESULT
	stdmethod SetRelativePath(LPCWSTR pszPathRel,DWORD dwReserved),HRESULT
	stdmethod Resolve(HWND hwnd,DWORD fFlags),HRESULT
	stdmethod SetPath(LPCWSTR pszFile),HRESULT
endinterface
$else
interface IShellLink ' IShellLinkA
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetPath(LPSTR pszFile,int cch,pointer pfd,DWORD fFlags),HRESULT
	stdmethod GetIDList(pointer ppidl),HRESULT
	stdmethod SetIDList(pointer pidl),HRESULT
	stdmethod GetDescription(LPSTR pszName,int cch),HRESULT
	stdmethod SetDescription(LPCSTR pszName),HRESULT
	stdmethod GetWorkingDirectory(LPSTR pszDir,int cch),HRESULT
	stdmethod SetWorkingDirectory(LPCSTR pszDir),HRESULT
	stdmethod GetArguments(LPSTR pszArgs,int cch),HRESULT
	stdmethod SetArguments(LPCSTR pszArgs),HRESULT
	stdmethod GetHotkey(pointer pwHotkey),HRESULT
	stdmethod SetHotkey(USHORT wHotkey),HRESULT
	stdmethod GetShowCmd(pointer piShowCmd),HRESULT
	stdmethod SetShowCmd(int iShowCmd),HRESULT
	stdmethod GetIconLocation(LPSTR pszIconPath,int cch,pointer piIcon),HRESULT
	stdmethod SetIconLocation(LPCSTR pszIconPath,int iIcon),HRESULT
	stdmethod SetRelativePath(LPCSTR pszPathRel,DWORD dwReserved),HRESULT
	stdmethod Resolve(HWND hwnd,DWORD fFlags),HRESULT
	stdmethod SetPath(LPCSTR pszFile),HRESULT
endinterface
$endif

typedef SPINITF UINT
$define SPINITF_NORMAL 0
$define SPINITF_MODAL 0x1
$define SPINITF_NOMINIMIZE 0x8

EXTERN _IID_IActionProgressDialog as GUID

'MIDL_INTERFACE("49ff1172-eadc-446d-9285-156453a6431c")
interface IActionProgressDialog ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Initialize(SPINITF flags,/* [in] */ LPCWSTR pszTitle,/* [in] */ LPCWSTR pszCancel),HRESULT
	stdmethod _Stop(),HRESULT

endinterface

EXTERN _IID_IHWEventHandler as GUID

'MIDL_INTERFACE("C1FB73D0-EC3A-4ba2-B512-8CDB9187B6D1")
interface IHWEventHandler ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Initialize(/* [in] */ LPCWSTR pszParams),HRESULT
	stdmethod HandleEvent(/* [in] */ LPCWSTR pszDeviceID,/* [in] */ LPCWSTR pszAltDeviceID,/* [in] */ LPCWSTR pszEventType),HRESULT
	stdmethod HandleEventWithContent(/* [in] */ LPCWSTR pszDeviceID,/* [in] */ LPCWSTR pszAltDeviceID,/* [in] */ LPCWSTR pszEventType,/* [in] */ LPCWSTR pszContentTypeHandler,IDataObject pdataobject),HRESULT

endinterface

$define ARCONTENT_AUTORUNINF 0x00000002
$define ARCONTENT_AUDIOCD	0x00000004
$define ARCONTENT_DVDMOVIE	0x00000008
$define ARCONTENT_BLANKCD	0x00000010
$define ARCONTENT_BLANKDVD	0x00000020
$define ARCONTENT_UNKNOWNCONTENT	0x00000040
$define ARCONTENT_AUTOPLAYPIX	0x00000080
$define ARCONTENT_AUTOPLAYMUSIC	0x00000100
$define ARCONTENT_AUTOPLAYVIDEO	0x00000200

EXTERN _IID_IQueryCancelAutoPlay as GUID

'MIDL_INTERFACE("DDEFE873-6997-4e68-BE26-39B633ADBE12")
interface IQueryCancelAutoPlay ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod AllowAutoPlay(/* [in] */ LPCWSTR pszPath,DWORD dwContentType,/* [in] */ LPCWSTR pszLabel,DWORD dwSerialNumber),HRESULT

endinterface

typedef SPBEGINF UINT
$define SPBEGINF_NORMAL 0
$define SPBEGINF_AUTOTIME 0x2
$define SPBEGINF_NOPROGRESSBAR 0x10
$define SPBEGINF_MARQUEEPROGRESS 0x20

typedef SPACTION int
$define SPACTION_NONE 0
$define SPACTION_MOVING SPACTION_NONE + 1
$define SPACTION_COPYING SPACTION_MOVING + 1
$define SPACTION_RECYCLING SPACTION_COPYING + 1
$define SPACTION_APPLYINGATTRIBS SPACTION_RECYCLING + 1
$define SPACTION_DOWNLOADING SPACTION_APPLYINGATTRIBS + 1
$define SPACTION_SEARCHING_INTERNET SPACTION_DOWNLOADING + 1
$define SPACTION_CALCULATING SPACTION_SEARCHING_INTERNET + 1
$define SPACTION_UPLOADING SPACTION_CALCULATING + 1
$define SPACTION_SEARCHING_FILES SPACTION_UPLOADING + 1

typedef SPTEXT int
$define SPTEXT_ACTIONDESCRIPTION 1
$define SPTEXT_ACTIONDETAIL SPTEXT_ACTIONDESCRIPTION + 1

EXTERN _IID_IActionProgress as GUID

'MIDL_INTERFACE("49ff1173-eadc-446d-9285-156453a6431c")
interface IActionProgress ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Begin(SPACTION action,SPBEGINF flags),HRESULT
	stdmethod UpdateProgress(ULONGLONG ulCompleted,ULONGLONG ulTotal),HRESULT
	stdmethod UpdateText(SPTEXT sptext,/* [in] */ LPCWSTR pszText,BOOL fMayCompact),HRESULT
	stdmethod QueryCancel(/*out*/pointer pfCancelled),HRESULT
	stdmethod ResetCancel(),HRESULT
	stdmethod _End(),HRESULT

endinterface

EXTERN _IID_IShellExtInit as GUID

'MIDL_INTERFACE("000214E8-0000-0000-C000-000000000046")
interface IShellExtInit ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Initialize(pointer pidlFolder,IDataObject pdtobj,HKEY hkeyProgID),HRESULT

endinterface

typedef EXPPS UINT
$define EXPPS_FILETYPES 0x1

EXTERN _IID_IShellPropSheetExt as GUID

'MIDL_INTERFACE("000214E9-0000-0000-C000-000000000046")
interface IShellPropSheetExt ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod AddPages(LPFNSVADDPROPSHEETPAGE pfnAddPage,LPARAM lParam),HRESULT
	stdmethod ReplacePage(EXPPS uPageID,LPFNSVADDPROPSHEETPAGE pfnReplaceWith,LPARAM lParam),HRESULT

endinterface

EXTERN _IID_IRemoteComputer as GUID

'MIDL_INTERFACE("000214FE-0000-0000-C000-000000000046")
interface IRemoteComputer ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Initialize(LPCWSTR pszMachine,BOOL bEnumerating),HRESULT

endinterface

EXTERN _IID_IQueryContinue as GUID

'MIDL_INTERFACE("7307055c-b24a-486b-9f25-163e597a28a9")
interface IQueryContinue ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod QueryContinue(),HRESULT
endinterface

EXTERN _IID_IUserNotification as GUID

'MIDL_INTERFACE("ba9711ba-5893-4787-a7e1-41277151550b")
interface IUserNotification ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetBalloonInfo(/* [in] */ LPCWSTR pszTitle,/* [in] */ LPCWSTR pszText,DWORD dwInfoFlags),HRESULT
	stdmethod SetBalloonRetry(DWORD dwShowTime,DWORD dwInterval,UINT cRetryCount),HRESULT
	stdmethod SetIconInfo(HICON hIcon,/* [in] */ LPCWSTR pszToolTip),HRESULT
	stdmethod Show(IQueryContinue pqc,DWORD dwContinuePollInterval),HRESULT
	stdmethod PlaySound(/* [in] */ LPCWSTR pszSoundName),HRESULT

endinterface

EXTERN _IID_IItemNameLimits as GUID

'MIDL_INTERFACE("1df0d7f1-b267-4d28-8b10-12e23202a5c4")
interface IItemNameLimits ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetValidCharacters(/*out*/LPWSTR ppwszValidChars,/*out*/LPWSTR ppwszInvalidChars),HRESULT
	stdmethod GetMaxLength(LPCWSTR pszName,/*out*/pointer piMaxNameLen),HRESULT

endinterface

$define SNCF_REFRESHLIST 0x00000001	' refresh the list(eg. from F5 or opening a folder)

EXTERN _IID_INetCrawler as GUID

'MIDL_INTERFACE("49c929ee-a1b7-4c58-b539-e63be392b6f3")
interface INetCrawler ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Update(DWORD dwFlags),HRESULT

endinterface

$define IEI_PRIORITY_MAX	0x7fffffff
$define IEI_PRIORITY_MIN	0x00000000
$define IEIT_PRIORITY_NORMAL	0x10000000
$define IEIFLAG_ASYNC	0x0001	' ask the extractor if it supports ASYNC extract(free threaded)
$define IEIFLAG_CACHE	0x0002	' returned from the extractor if it does NOT cache the thumbnail
$define IEIFLAG_ASPECT	0x0004	' passed to the extractor to beg it to render to the aspect ratio of the supplied rect
$define IEIFLAG_OFFLINE	0x0008	' if the extractor shouldn't hit the net to get any content neede for the rendering
$define IEIFLAG_GLEAM	0x0010	' does the image have a gleam ? this will be returned if it does
$define IEIFLAG_SCREEN	0x0020	' render as if for the screen	(this is exlusive with IEIFLAG_ASPECT)
$define IEIFLAG_ORIGSIZE	0x0040	' render to the approx size passed, but crop if neccessary
$define IEIFLAG_NOSTAMP	0x0080	' returned from the extractor if it does NOT want an icon stamp on the thumbnail
$define IEIFLAG_NOBORDER	0x0100	' returned from the extractor if it does NOT want an a border around the thumbnail
$define IEIFLAG_QUALITY	0x0200	' passed to the Extract method to indicate that a slower, higher quality image is desired, re-compute the thumbnail
$define IEIFLAG_REFRESH	0x0400	' returned from the extractor if it would like to have Refresh Thumbnail available

EXTERN _IID_IExtractImage as GUID

'MIDL_INTERFACE("BB2E617C-0920-11d1-9A0B-00C04FC2D6C1")
interface IExtractImage ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetLocation(LPWSTR pszPathBuffer, DWORD cch, pointer pdwPriority, pointer prgSize,DWORD dwRecClrDepth,pointer pdwFlags),HRESULT
	stdmethod Extract(pointer phBmpThumbnail),HRESULT
endinterface

EXTERN _IID_IExtractImage2 as GUID

'MIDL_INTERFACE("953BB1EE-93B4-11d1-98A3-00C04FB687DA")
interface IExtractImage2 ' IExtractImage
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetLocation(LPWSTR pszPathBuffer, DWORD cch, pointer pdwPriority, pointer prgSize,DWORD dwRecClrDepth,pointer pdwFlags),HRESULT
	stdmethod Extract(pointer phBmpThumbnail),HRESULT

'IExtractImage2
	stdmethod GetDateStamp(/*out*/pointer pDateStamp),HRESULT

endinterface

EXTERN _IID_IUserEventTimerCallback as GUID

'MIDL_INTERFACE("e9ead8e6-2a25-410e-9b58-a9fbef1dd1a2")
interface IUserEventTimerCallback ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod UserEventTimerProc(ULONG uUserEventTimerID,UINT uTimerElapse),HRESULT

endinterface

EXTERN _IID_IUserEventTimer as GUID

'MIDL_INTERFACE("0F504B94-6E42-42E6-99E0-E20FAFE52AB4")
interface IUserEventTimer ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetUserEventTimer(HWND hWnd,UINT uCallbackMessage,UINT uTimerElapse,IUserEventTimerCallback pUserEventTimerCallback,/*out in*/pointer puUserEventTimerID),HRESULT
	stdmethod KillUserEventTimer(HWND hWnd,ULONG uUserEventTimerID),HRESULT
	stdmethod GetUserEventTimerElapsed(HWND hWnd,ULONG uUserEventTimerID,/*out*/pointer puTimerElapsed),HRESULT
	stdmethod InitTimerTickInterval(UINT uTimerTickIntervalMs),HRESULT

endinterface

EXTERN _IID_IDockingWindow as GUID
'MIDL_INTERFACE("012dd920-7b26-11d0-8ca9-00a0c92dbfe8")
interface IDockingWindow ' IOleWindow
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod ShowDW(BOOL fShow),HRESULT
	stdmethod CloseDW(DWORD dwReserved),HRESULT
	stdmethod ResizeBorderDW(pointer prcBorder,IUnknown punkToolbarSite,BOOL fReserved),HRESULT

endinterface

$define DBIM_MINSIZE	0x0001
$define DBIM_MAXSIZE	0x0002
$define DBIM_INTEGRAL	0x0004
$define DBIM_ACTUAL	0x0008
$define DBIM_TITLE	0x0010
$define DBIM_MODEFLAGS	0x0020
$define DBIM_BKCOLOR	0x0040
'$include <pshpack8.h>
type DESKBANDINFO
	DWORD dwMask
	POINTL ptMinSize
	POINTL ptMaxSize
	POINTL ptIntegral
	POINTL ptActual
	iwstring wszTitle[ 256 ]
	DWORD dwModeFlags
	COLORREF crBkgnd
endtype

'$include <poppack.h>
$define DBIMF_NORMAL	0x0000
$define DBIMF_FIXED	0x0001
$define DBIMF_FIXEDBMP	0x0004	' a fixed background bitmap(if supported)
$define DBIMF_VARIABLEHEIGHT	0x0008
$define DBIMF_UNDELETEABLE	0x0010
$define DBIMF_DEBOSSED	0x0020
$define DBIMF_BKCOLOR	0x0040
$define DBIMF_USECHEVRON	0x0080
$define DBIMF_BREAK	0x0100
$define DBIMF_ADDTOFRONT	0x0200
$define DBIMF_TOPALIGN	0x0400
$define DBIF_VIEWMODE_NORMAL	0x0000
$define DBIF_VIEWMODE_VERTICAL	0x0001
$define DBIF_VIEWMODE_FLOATING	0x0002
$define DBIF_VIEWMODE_TRANSPARENT	0x0004

'enum __MIDL___MIDL_itf_shobjidl_0226_0002
$define DBID_BANDINFOCHANGED 0
$define DBID_SHOWONLY 1
$define DBID_MAXIMIZEBAND 2
$define DBID_PUSHCHEVRON 3
$define DBID_DELAYINIT 4
$define DBID_FINISHINIT 5
$define DBID_SETWINDOWTHEME 6
$define DBID_PERMITAUTOHIDE 7

$define DBPC_SELECTFIRST	-1
$define DBPC_SELECTLAST	-2
'$define CGID_DeskBand IID_IDeskBand

EXTERN _IID_IDeskBand as GUID

'MIDL_INTERFACE("EB0FE172-1A3A-11D0-89B3-00A0C90A90AC")
interface IDeskBand ' IDockingWindow
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod ShowDW(BOOL fShow),HRESULT
	stdmethod CloseDW(DWORD dwReserved),HRESULT
	stdmethod ResizeBorderDW(pointer prcBorder,pointer punkToolbarSite,BOOL fReserved),HRESULT
'IDeskBand
	stdmethod GetBandInfo(DWORD dwBandID,DWORD dwViewMode,/*out in*/pointer pdbi),HRESULT

endinterface

EXTERN _IID_ITaskbarList as GUID

'MIDL_INTERFACE("56FDF342-FD6D-11d0-958A-006097C9A090")
interface ITaskbarList ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod HrInit(),HRESULT
	stdmethod AddTab(HWND hwnd),HRESULT
	stdmethod DeleteTab(HWND hwnd),HRESULT
	stdmethod ActivateTab(HWND hwnd),HRESULT
	stdmethod SetActiveAlt(HWND hwnd),HRESULT
endinterface

EXTERN _IID_ITaskbarList2 as GUID

'MIDL_INTERFACE("602D4995-B13A-429b-A66E-1935E44F4317")
interface ITaskbarList2 ' ITaskbarList
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod HrInit(),HRESULT
	stdmethod AddTab(HWND hwnd),HRESULT
	stdmethod DeleteTab(HWND hwnd),HRESULT
	stdmethod ActivateTab(HWND hwnd),HRESULT
	stdmethod SetActiveAlt(HWND hwnd),HRESULT
'ITaskbarList2
	stdmethod MarkFullscreenWindow(HWND hwnd, BOOL fFullscreen),HRESULT
endinterface

EXTERN _IID_ICDBurn as GUID

'MIDL_INTERFACE("3d73a659-e5d0-4d42-afc0-5121ba425c8d")
interface ICDBurn ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetRecorderDriveLetter(LPWSTR pszDrive, UINT cch),HRESULT
	stdmethod Burn(HWND hwnd),HRESULT
	stdmethod HasRecordableDrive(pointer pfHasRecorder),HRESULT
endinterface

$define IDD_WIZEXTN_FIRST	0x5000
$define IDD_WIZEXTN_LAST	0x5100

EXTERN _IID_IWizardSite as GUID

'MIDL_INTERFACE("88960f5b-422f-4e7b-8013-73415381c3c3")
interface IWizardSite ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetPreviousPage(/*out*/pointer phpage),HRESULT
	stdmethod GetNextPage(/*out*/pointer phpage),HRESULT
	stdmethod GetCancelledPage(/*out*/pointer phpage),HRESULT

endinterface

EXTERN _IID_IWizardExtension as GUID

'MIDL_INTERFACE("c02ea696-86cc-491e-9b23-74394a0444a8")
interface IWizardExtension ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod AddPages(/*out in*/pointer aPages,UINT cPages,/*out*/pointer pnPagesAdded),HRESULT
	stdmethod GetFirstPage(/*out*/pointer phpage),HRESULT
	stdmethod GetLastPage(/*out*/pointer phpage),HRESULT

endinterface

EXTERN _IID_IWebWizardExtension as GUID

'MIDL_INTERFACE("0e6b3f66-98d1-48c0-a222-fbde74e2fbc5")
interface IWebWizardExtension ' IWizardExtension
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod AddPages(/*out in*/pointer aPages,UINT cPages,/*out*/pointer pnPagesAdded),HRESULT
	stdmethod GetFirstPage(/*out*/pointer phpage),HRESULT
	stdmethod GetLastPage(/*out*/pointer phpage),HRESULT
'IWebWizardExtension
	stdmethod SetInitialURL(/* [in] */ LPCWSTR pszURL),HRESULT
	stdmethod SetErrorURL(/* [in] */ LPCWSTR pszErrorURL),HRESULT

endinterface

'$define SID_WebWizardHost IID_IWebWizardExtension
$define SHPWHF_NORECOMPRESS	0x00000001	' don't allow/prompt for recompress of streams
$define SHPWHF_NONETPLACECREATE	0x00000002	' don't create a network place when transfer is complete
$define SHPWHF_NOFILESELECTOR	0x00000004	' don't show the file selector
$define SHPWHF_VALIDATEVIAWEBFOLDERS	0x00010000	' enable web folders to validate network places(ANP support)

EXTERN _IID_IPublishingWizard as GUID

'MIDL_INTERFACE("aa9198bb-ccec-472d-beed-19a4f6733f7a")
interface IPublishingWizard ' IWizardExtension
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod AddPages(/*out in*/pointer aPages,UINT cPages,/*out*/pointer pnPagesAdded),HRESULT
	stdmethod GetFirstPage(/*out*/pointer phpage),HRESULT
	stdmethod GetLastPage(/*out*/pointer phpage),HRESULT
'IPublishingWizard
	stdmethod Initialize(IDataObject pdo,DWORD dwOptions,/* [in] */ LPCWSTR pszServiceProvider),HRESULT
	stdmethod GetTransferManifest(/*out*/pointer phrFromTransfer,/*out*/pointer pdocManifest),HRESULT

endinterface

EXTERN _IID_IFolderViewHost as GUID

'MIDL_INTERFACE("1ea58f02-d55a-411d-b09e-9e65ac21605b")
interface IFolderViewHost ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Initialize(HWND hwndParent,IDataObject pdo,pointer prc),HRESULT

endinterface

$define ACDD_VISIBLE	0x0001

EXTERN _IID_IAutoCompleteDropDown as GUID

'MIDL_INTERFACE("3CD141F4-3C6A-11d2-BCAA-00C04FD929DB")
interface IAutoCompleteDropDown ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetDropDownStatus(/*out*/pointer pdwFlags,/*out*/LPWSTR ppwszString),HRESULT
	stdmethod ResetEnumerator(),HRESULT

endinterface

$define PPW_LAUNCHEDBYUSER	0x00000001	' The wizard was launch explicitly by the user, not on demand by the key manager

EXTERN _IID_IModalWindow as GUID

'MIDL_INTERFACE("b4db1657-70d7-485e-8e3e-6fcb5a5c1802")
interface IModalWindow ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Show(HWND hwndParent),HRESULT
endinterface

EXTERN _IID_IPassportWizard as GUID

'MIDL_INTERFACE("a09db586-9180-41ac-9114-460a7f362b76")
interface IPassportWizard ' IModalWindow
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Show(HWND hwndParent),HRESULT
'IPassportWizard
	stdmethod SetOptions(DWORD dwOptions),HRESULT
endinterface

$define PROPSTR_EXTENSIONCOMPLETIONSTATE L"ExtensionCompletionState"

'enum __MIDL___MIDL_itf_shobjidl_0237_0001
$define CDBE_RET_DEFAULT 0
$define CDBE_RET_DONTRUNOTHEREXTS 0x1
$define CDBE_RET_STOPWIZARD 0x2

'$define SID_CDWizardHost IID_ICDBurnExt

'enum __MIDL_ICDBurnExt_0002
$define CDBE_TYPE_MUSIC 0x1
$define CDBE_TYPE_DATA 0x2
$define CDBE_TYPE_ALL 0xffffffff

EXTERN _IID_ICDBurnExt as GUID

'MIDL_INTERFACE("2271dcca-74fc-4414-8fb7-c56b05ace2d7")
interface ICDBurnExt ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetSupportedActionTypes(/*out*/pointer pdwActions),HRESULT
endinterface

'typedef void(pointer PFDVENUMREADYBALLBACK)(LPVOID pvData)

EXTERN _IID_IDVGetEnum as GUID

'MIDL_INTERFACE("70F55181-5FEA-4900-B6B8-7343CB0A348C")
interface IDVGetEnum ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetEnumReadyCallback(PFDVENUMREADYBALLBACK pfn, LPVOID pvData),HRESULT
	stdmethod CreateEnumIDListFromContents(pointer pidlFolder, DWORD dwEnumFlags, /*out*/pointer ppEnumIDList),HRESULT
endinterface

EXTERN _IID_IInsertItem as GUID

'MIDL_INTERFACE("D2B57227-3D23-4b95-93C0-492BD454C356")
interface IInsertItem ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod InsertItem(pointer pidl),HRESULT
endinterface

EXTERN _IID_IDeskBar as GUID

'MIDL_INTERFACE("EB0FE173-1A3A-11D0-89B3-00A0C90A90AC")
interface IDeskBar ' IOleWindow
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod SetClient(pointer punkClient),HRESULT
	stdmethod GetClient(pointer ppunkClient),HRESULT
	stdmethod OnPosRectChangeDB(pointer prc),HRESULT
endinterface

$define MBHANDCID_PIDLSELECT 0

EXTERN _IID_IMenuBand as GUID

'MIDL_INTERFACE("568804CD-CBD7-11d0-9816-00C04FD91972")
interface IMenuBand ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod IsMenuMessage(pointer pmsg),HRESULT
	stdmethod TranslateMenuMessage(/*out in*/pointer pmsg, /*out*/pointer plRet),HRESULT
endinterface

EXTERN _IID_IFolderBandPriv as GUID
'MIDL_INTERFACE("47c01f95-e185-412c-b5c5-4f27df965aea")
interface IFolderBandPriv ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetCascade(BOOL f),HRESULT
	stdmethod SetAccelerators(BOOL f),HRESULT
	stdmethod SetNoIcons(BOOL f),HRESULT
	stdmethod SetNoText(BOOL f),HRESULT
endinterface

'$endif 	/* __IFolderBandPriv_INTERFACE_DEFINED__ */

/* interface __MIDL_itf_shobjidl_0243 */
/* [local] */

'#if _WIN32_IE >= 0x0400
'$include <pshpack8.h>
type BANDSITEINFO
	DWORD dwMask
	DWORD dwState
	DWORD dwStyle
endtype

'$include <poppack.h>

'enum __MIDL___MIDL_itf_shobjidl_0243_0001
$define BSID_BANDADDED 0
$define BSID_BANDREMOVED BSID_BANDADDED + 1

$define BSIM_STATE	0x00000001
$define BSIM_STYLE	0x00000002
$define BSSF_VISIBLE	0x00000001
$define BSSF_NOTITLE	0x00000002
$define BSSF_UNDELETEABLE	0x00001000
$define BSIS_AUTOGRIPPER	0x00000000
$define BSIS_NOGRIPPER	0x00000001
$define BSIS_ALWAYSGRIPPER	0x00000002
$define BSIS_LEFTALIGN	0x00000004
$define BSIS_SINGLECLICK	0x00000008
$define BSIS_NOCONTEXTMENU	0x00000010
$define BSIS_NODROPTARGET	0x00000020
$define BSIS_NOCAPTION	0x00000040
$define BSIS_PREFERNOLINEBREAK	0x00000080
$define BSIS_LOCKED	0x00000100
'$define SID_SBandSite IID_IBandSite
'$define CGID_BandSite IID_IBandSite

EXTERN _IID_IBandSite as GUID

'"4CF504B0-DE96-11D0-8B3F-00A0C911E8E5"
interface IBandSite ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod AddBand(pointer punk),HRESULT
	stdmethod EnumBands(UINT uBand, /* [out] */pointer pdwBandID),HRESULT
	stdmethod QueryBand(DWORD dwBandID,/*out*/pointer ppstb,/*out*/pointer pdwState,LPWSTR pszName,int cchName),HRESULT
	stdmethod SetBandState(DWORD dwBandID,DWORD dwMask,DWORD dwState),HRESULT
	stdmethod RemoveBand(DWORD dwBandID),HRESULT
	stdmethod GetBandObject(DWORD dwBandID,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod SetBandSiteInfo(pointer pbsinfo),HRESULT
	stdmethod GetBandSiteInfo(/*out in*/pointer pbsinfo),HRESULT

endinterface

'$endif // _WIN32_IE >= 0x0400

EXTERN _IID_INamespaceWalkCB as GUID

'"d92995f8-cf5e-4a76-bf59-ead39ea2b97e"
interface INamespaceWalkCB ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod FoundItem(IShellFolder psf,pointer pidl),HRESULT
	stdmethod EnterFolder(IShellFolder psf,pointer pidl),HRESULT
	stdmethod LeaveFolder(IShellFolder psf,pointer pidl),HRESULT
	stdmethod InitializeProgressDialog(/*out*/LPWSTR ppszTitle,/*out*/LPWSTR ppszCancel),HRESULT

endinterface

'enum __MIDL_INamespaceWalk_0001
$define NSWF_NONE_IMPLIES_ALL 0x1
$define NSWF_ONE_IMPLIES_ALL 0x2
$define NSWF_DONT_TRAVERSE_LINKS 0x4
$define NSWF_DONT_ACCUMULATE_RESULT 0x8
$define NSWF_TRAVERSE_STREAM_JUNCTIONS 0x10
$define NSWF_FILESYSTEM_ONLY 0x20
$define NSWF_SHOW_PROGRESS 0x40
$define NSWF_FLAG_VIEWORDER 0x80
$define NSWF_IGNORE_AUTOPLAY_HIDA 0x100

EXTERN _IID_INamespaceWalk as GUID

'MIDL_INTERFACE("57ced8a7-3f4a-432c-9350-30f24483f74f")
interface INamespaceWalk ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Walk(IUnknown punkToWalk,DWORD dwFlags,int cDepth,INamespaceWalkCB pnswcb),HRESULT
	stdmethod GetIDArrayResult(/*out*/pointer pcItems,pointer pppidl),HRESULT

endinterface

EXTERN _IID_IRegTreeItem as GUID

'MIDL_INTERFACE("A9521922-0812-4d44-9EC3-7FD38C726F3D")
interface IRegTreeItem ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetCheckState(/*out*/pointer pbCheck),HRESULT
	stdmethod SetCheckState(BOOL bCheck),HRESULT

endinterface

'enum __MIDL___MIDL_itf_shobjidl_0247_0001
$define MPOS_EXECUTE 0
$define MPOS_FULLCANCEL MPOS_EXECUTE + 1
$define MPOS_CANCELLEVEL MPOS_FULLCANCEL + 1
$define MPOS_SELECTLEFT MPOS_CANCELLEVEL + 1
$define MPOS_SELECTRIGHT MPOS_SELECTLEFT + 1
$define MPOS_CHILDTRACKING MPOS_SELECTRIGHT + 1

'enum __MIDL___MIDL_itf_shobjidl_0247_0002
$define MPPF_SETFOCUS 0x1
$define MPPF_INITIALSELECT 0x2
$define MPPF_NOANIMATE 0x4
$define MPPF_KEYBOARD 0x10
$define MPPF_REPOSITION 0x20
$define MPPF_FORCEZORDER 0x40
$define MPPF_FINALSELECT 0x80
$define MPPF_TOP 0x20000000
$define MPPF_LEFT 0x40000000
$define MPPF_RIGHT 0x60000000
$define MPPF_BOTTOM 0x80000000
$define MPPF_POS_MASK 0xe0000000

EXTERN _IID_IMenuPopup as GUID

'MIDL_INTERFACE("D1E7AFEB-6A2E-11d0-8C78-00C04FD918B4")
interface IMenuPopup ' IDeskBar
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetWindow(pointer phwnd),HRESULT
	stdmethod ContextSensitiveHelp(BOOL fEnterMode),HRESULT
	stdmethod SetClient(pointer punkClient),HRESULT
	stdmethod GetClient(pointer ppunkClient),HRESULT
	stdmethod OnPosRectChangeDB(pointer prc),HRESULT
'IMenuPopup
	stdmethod Popup(pointer ppt,pointer prcExclude,DWORD dwFlags),HRESULT
	stdmethod OnSelect(DWORD dwSelectType),HRESULT
	stdmethod SetSubMenu(IMenuPopup pmp,BOOL fSet),HRESULT

endinterface



typedef SIGDN int
$define SIGDN_NORMALDISPLAY 0
$define SIGDN_PARENTRELATIVEPARSING 0x80018001
$define SIGDN_PARENTRELATIVEFORADDRESSBAR 0x8001c001
$define SIGDN_DESKTOPABSOLUTEPARSING 0x80028000
$define SIGDN_PARENTRELATIVEEDITING 0x80031001
$define SIGDN_DESKTOPABSOLUTEEDITING 0x8004c000
$define SIGDN_FILESYSPATH 0x80058000
$define SIGDN_URL 0x80068000

typedef SICHINTF UINT
$define SICHINT_DISPLAY 0
$define SICHINT_ALLFIELDS 0x80000000
$define SICHINT_CANONICAL 0x10000000

EXTERN _IID_IShellItem as GUID

'MIDL_INTERFACE("43826d1e-e718-42ee-bc55-a1e261c37bfe")
interface IShellItem ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod BindToHandler(IBindCtx pbc,pointer rbhid,pointer riid,/*out*/pointer ppvOut),HRESULT
	stdmethod GetParent(/*out*/pointer ppsi),HRESULT
	stdmethod GetDisplayName(SIGDN sigdnName,/*out*/pointer ppszName),HRESULT
	stdmethod GetAttributes(SFGAOF sfgaoMask,/*out*/pointer psfgaoAttribs),HRESULT
	stdmethod Compare(IShellItem psi,SICHINTF hint,/*out*/pointer piOrder),HRESULT

endinterface

EXTERN _IID_IImageRecompress as GUID

'MIDL_INTERFACE("505f1513-6b3e-4892-a272-59f8889a4d3e")
interface IImageRecompress ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod RecompressImage(IShellItem psi,Int cx,Int cy,Int iQuality,IStorage pstg,pointer ppstrmOut),HRESULT

endinterface

EXTERN _IID_IDefViewSafety as GUID

'MIDL_INTERFACE("9A93B3FB-4E75-4c74-871A-2CDA667F39A5")
interface IDefViewSafety ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod IsSafePage(),HRESULT

endinterface

EXTERN _IID_IContextMenuSite as GUID

'MIDL_INTERFACE("0811AEBE-0B87-4C54-9E72-548CF649016B")
interface IContextMenuSite ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod DoContextMenuPopup(IUnknown punkContextMenu,UINT fFlags,pointer pt),HRESULT

endinterface

/* interface __MIDL_itf_shobjidl_0253 */
/* [local] */

'$include <pshpack1.h>
type DELEGATEITEMID,1
	USHORT cbSize
	USHORT wOuter
	USHORT cbInner
	BYTE _rgb[ 1 ]
endtype

'$include <poppack.h>
'typedef UNALIGNED DELEGATEITEMID* PCDELEGATEITEMID
'typedef UNALIGNED DELEGATEITEMID* PDELEGATEITEMID

EXTERN _IID_IDelegateFolder as GUID

'MIDL_INTERFACE("ADD8BA80-002B-11D0-8F0F-00C04FD7D062")
interface IDelegateFolder ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetItemAlloc(IMalloc pmalloc),HRESULT

endinterface

/* interface __MIDL_itf_shobjidl_0254 */
/* [local] */

' INTERFACE: IBrowserFrameOptions
' This interface was implemented so a browser or host can ask a ShellView/ShelNameSpace what
' kind of 'Behavior' is appropriate for that view.
'	IBrowserFrameOptions::GetBrowserOptions()
'	dwMask is the logical OR of bits to look for.	pdwOptions is not optional and
'	it's return value will always equal or will be a subset of dwMask.
'	If the function succeeds, the return value must be S_OK and pdwOptions needs to be filled in.
'	If the function fails, pdwOptions needs to be filled in with BFO_NONE.

'enum __MIDL_IBrowserFrameOptions_0001
$define BFO_NONE 0
$define BFO_BROWSER_PERSIST_SETTINGS 0x1
$define BFO_RENAME_FOLDER_OPTIONS_TOINTERNET 0x2
$define BFO_BOTH_OPTIONS 0x4
$define BIF_PREFER_INTERNET_SHORTCUT 0x8
$define BFO_BROWSE_NO_IN_NEW_PROCESS 0x10
$define BFO_ENABLE_HYPERLINK_TRACKING 0x20
$define BFO_USE_IE_OFFLINE_SUPPORT 0x40
$define BFO_SUBSTITUE_INTERNET_START_PAGE 0x80
$define BFO_USE_IE_LOGOBANDING 0x100
$define BFO_ADD_IE_TOCAPTIONBAR 0x200
$define BFO_USE_DIALUP_REF 0x400
$define BFO_USE_IE_TOOLBAR 0x800
$define BFO_NO_PARENT_FOLDER_SUPPORT 0x1000
$define BFO_NO_REOPEN_NEXT_RESTART 0x2000
$define BFO_GO_HOME_PAGE 0x4000
$define BFO_PREFER_IEPROCESS 0x8000
$define BFO_SHOW_NAVIGATION_CANCELLED 0x10000
$define BFO_USE_IE_STATUSBAR 0x20000
$define BFO_QUERY_ALL 0xffffffff

typedef BROWSERFRAMEOPTIONS DWORD

EXTERN _IID_IBrowserFrameOptions as GUID

'MIDL_INTERFACE("10DF43C8-1DBE-11d3-8B34-006097DF5BD4")
interface IBrowserFrameOptions ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod GetFrameOptions(BROWSERFRAMEOPTIONS dwMask,/*out*/pointer pdwOptions),HRESULT

endinterface

typedef NWMF int
$define NWMF_UNLOADING 0x1
$define NWMF_USERINITED 0x2
$define NWMF_FIRST 0x4
$define NWMF_OVERRIDEKEY 0x8
$define NWMF_SHOWHELP 0x10
$define NWMF_HTMLDIALOG 0x20
$define NWMF_FROMDIALOGCHILD 0x40
$define NWMF_USERREQUESTED 0x80
$define NWMF_USERALLOWED 0x100

'$define SID_SNewWindowManager IID_INewWindowManager

EXTERN _IID_INewWindowManager as GUID
'MIDL_INTERFACE("D2BC4C84-3F72-4a52-A604-7BCBF3982CBB")
interface INewWindowManager ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod EvaluateNewWindow(LPCWSTR pszUrl,LPCWSTR pszName,LPCWSTR pszUrlContext,LPCWSTR pszFeatures,BOOL fReplace,DWORD dwFlags,DWORD dwUserActionTime),HRESULT

endinterface

'$include <pshpack8.h>
type SMDATA
	DWORD dwMask
	DWORD dwFlags
	HMENU hmenu
	HWND hwnd
	UINT uId
	UINT uIdParent
	UINT uIdAncestor
	IUnknown punk
	pointer pidlFolder
	pointer pidlItem
	IShellFolder psf
	pointer pvUserData
endtype

' Mask
$define SMDM_SHELLFOLDER	0x00000001	' This is for an item in the band
$define SMDM_HMENU	0x00000002	' This is for the Band itself
$define SMDM_TOOLBAR	0x00000004	' Plain toolbar, not associated with a shell folder or hmenu
' Flags(bitmask)
type SMINFO
	DWORD dwMask
	DWORD dwType
	DWORD dwFlags
	int iIcon
endtype

'struct SMINFO* PSMINFO

type SHCSCHANGENOTIFYSTRUCT
	LONG lEvent
	pointer pidl1
	pointer pidl2
endtype

'struct SHCSCHANGENOTIFYSTRUCT* PSMCSHCHANGENOTIFYSTRUCT

'$include <poppack.h>

'enum __MIDL___MIDL_itf_shobjidl_0256_0001
$define SMIM_TYPE 0x1
$define SMIM_FLAGS 0x2
$define SMIM_ICON 0x4

'enum __MIDL___MIDL_itf_shobjidl_0256_0002
$define SMIT_SEPARATOR 0x1
$define SMIT_STRING 0x2

'enum __MIDL___MIDL_itf_shobjidl_0256_0003
$define SMIF_ICON 0x1
$define SMIF_ACCELERATOR 0x2
$define SMIF_DROPTARGET 0x4
$define SMIF_SUBMENU 0x8
$define SMIF_CHECKED 0x20
$define SMIF_DROPCASCADE 0x40
$define SMIF_HIDDEN 0x80
$define SMIF_DISABLED 0x100
$define SMIF_TRACKPOPUP 0x200
$define SMIF_DEMOTED 0x400
$define SMIF_ALTSTATE 0x800
$define SMIF_DRAGNDROP 0x1000
$define SMIF_NEW 0x2000

$define SMC_INITMENU	0x00000001	' The callback is called to init a menuband
$define SMC_CREATE	0x00000002
$define SMC_EXITMENU	0x00000003	' The callback is called when menu is collapsing
$define SMC_GETINFO	0x00000005	' The callback is called to return DWORD values
$define SMC_GETSFINFO	0x00000006	' The callback is called to return DWORD values
$define SMC_GETOBJECT	0x00000007	' The callback is called to get some object
$define SMC_GETSFOBJECT	0x00000008	' The callback is called to get some object
$define SMC_SFEXEC	0x00000009	' The callback is called to execute an shell folder item
$define SMC_SFSELECTITEM	0x0000000A	' The callback is called when an item is selected
$define SMC_REFRESH	0x00000010	' Menus have completely refreshed. Reset your state.
$define SMC_DEMOTE	0x00000011	' Demote an item
$define SMC_PROMOTE	0x00000012	' Promote an item, wParam = SMINV_* flag
$define SMC_DEFAULTICON	0x00000016	' Returns Default icon location in wParam, index in lParam
$define SMC_NEWITEM	0x00000017	' Notifies item is not in the order stream.
$define SMC_CHEVRONEXPAND	0x00000019	' Notifies of a expansion via the chevron
$define SMC_DISPLAYCHEVRONTIP	0x0000002A	' S_OK display, S_FALSE not.
$define SMC_SETSFOBJECT	0x0000002D	' Called to save the passed object
$define SMC_SHCHANGENOTIFY	0x0000002E	' Called when a Change notify is received. lParam points to SMCSHCHANGENOTIFYSTRUCT
$define SMC_CHEVRONGETTIP	0x0000002F	' Called to get the chevron tip text. wParam = Tip title, Lparam = TipText Both MAX_PATH
$define SMC_SFDDRESTRICTED	0x00000030	' Called requesting if it's ok to drop. wParam = IDropTarget.

EXTERN _IID_IShellMenuCallback as GUID


'MIDL_INTERFACE("4CA300A1-9B8D-11d1-8B22-00C04FD918D0")
interface IShellMenuCallback ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod CallbackSM(/*out in*/pointer psmd,UINT uMsg,WPARAM wParam,LPARAM lParam),HRESULT

endinterface

typedef ATTACHMENT_PROMPT int
$define ATTACHMENT_PROMPT_NONE 0
$define ATTACHMENT_PROMPT_SAVE 0x1
$define ATTACHMENT_PROMPT_EXEC 0x2
$define ATTACHMENT_PROMPT_EXEC_OR_SAVE 0x3

typedef ATTACHMENT_ACTION int
$define ATTACHMENT_ACTION_CANCEL 0
$define ATTACHMENT_ACTION_SAVE 0x1
$define ATTACHMENT_ACTION_EXEC 0x2

EXTERN _IID_IAttachmentExecute as GUID

'MIDL_INTERFACE("73db1241-1e85-4581-8e4f-a81e1d0f8c57")
interface IAttachmentExecute ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod SetClientTitle(/* [in] */ LPCWSTR pszTitle),HRESULT
	stdmethod SetClientGuid(pointer guid),HRESULT
	stdmethod SetLocalPath(/* [in] */ LPCWSTR pszLocalPath),HRESULT
	stdmethod SetFileName(/* [in] */ LPCWSTR pszFileName),HRESULT
	stdmethod SetSource(/* [in] */ LPCWSTR pszSource),HRESULT
	stdmethod SetReferrer(/* [in] */ LPCWSTR pszReferrer),HRESULT
	stdmethod CheckPolicy(),HRESULT
	stdmethod Prompt(HWND hwnd,ATTACHMENT_PROMPT prompt,/*out*/pointer paction),HRESULT
	stdmethod Save(),HRESULT
	stdmethod Execute(HWND hwnd,/* [in] */ LPCWSTR pszVerb,pointer phProcess),HRESULT
	stdmethod SaveWithUI(HWND hwnd),HRESULT
	stdmethod ClearClientState(),HRESULT

endinterface

/* interface __MIDL_itf_shobjidl_0258 */
/* [local] */

$define SMINIT_DEFAULT	0x00000000	' No Options
$define SMINIT_RESTRICT_DRAGDROP	0x00000002	' Don't allow Drag and Drop
$define SMINIT_TOPLEVEL	0x00000004	' This is the top band.
$define SMINIT_CACHED	0x00000010
$define SMINIT_VERTICAL	0x10000000	' This is a vertical menu
$define SMINIT_HORIZONTAL	0x20000000	' This is a horizontal menu	(does not inherit)
$define ANCESTORDEFAULT	-1
$define SMSET_TOP	0x10000000	' Bias this namespace to the top of the menu
$define SMSET_BOTTOM	0x20000000	' Bias this namespace to the bottom of the menu
$define SMSET_DONTOWN	0x00000001	' The Menuband doesn't own the non-ref counted object
$define SMINV_REFRESH	0x00000001
$define SMINV_ID	0x00000008

EXTERN _IID_IShellMenu as GUID


'MIDL_INTERFACE("EE1F7637-E138-11d1-8379-00C04FD918D0")
interface IShellMenu ' IUnknown
	stdmethod QueryInterface(pointer riid,pointer ppvObject),HRESULT
	stdmethod AddRef(),ULONG
	stdmethod Release(),ULONG
	stdmethod Initialize(IShellMenuCallback psmc,UINT uId,UINT uIdAncestor,DWORD dwFlags),HRESULT
	stdmethod GetMenuInfo(/*out*/pointer ppsmc,/*out*/pointer puId,/*out*/pointer puIdAncestor,/*out*/pointer pdwFlags),HRESULT
	stdmethod SetShellFolder(IShellFolder psf,pointer pidlFolder,HKEY hKey,DWORD dwFlags),HRESULT
	stdmethod GetShellFolder(/*out*/pointer pdwFlags,/*out*/pointer ppidl,pointer riid,/*out*/pointer ppv),HRESULT
	stdmethod _SetMenu(HMENU hmenu,HWND hwnd,DWORD dwFlags),HRESULT
	stdmethod GetMenu(/*out*/pointer phmenu,/*out*/pointer phwnd,/*out*/pointer pdwFlags),HRESULT
	stdmethod InvalidateItem(pointer psmd,DWORD dwFlags),HRESULT
	stdmethod _GetState(/*out*/pointer psmd),HRESULT
	stdmethod SetMenuToolbar(IUnknown punk,DWORD dwFlags),HRESULT

endinterface

'$define SID_PublishingWizard CLSID_PublishingWizard

EXTERN _LIBID_ShellObjects as GUID

EXTERN _CLSID_QueryCancelAutoPlay as GUID
EXTERN _CLSID_DriveSizeCategorizer as GUID
EXTERN _CLSID_DriveTypeCategorizer as GUID
EXTERN _CLSID_FreeSpaceCategorizer as GUID
EXTERN _CLSID_TimeCategorizer as GUID
EXTERN _CLSID_SizeCategorizer as GUID
EXTERN _CLSID_AlphabeticalCategorizer as GUID
EXTERN _CLSID_MergedCategorizer as GUID
EXTERN _CLSID_ImageProperties as GUID
EXTERN _CLSID_PropertiesUI as GUID
EXTERN _CLSID_UserNotification as GUID
EXTERN _CLSID_UserEventTimerCallback as GUID
EXTERN _CLSID_UserEventTimer as GUID
EXTERN _CLSID_NetCrawler as GUID
EXTERN _CLSID_CDBurn as GUID
EXTERN _CLSID_TaskbarList as GUID
EXTERN _CLSID_WebWizardHost as GUID
EXTERN _CLSID_PublishDropTarget as GUID
EXTERN _CLSID_PublishingWizard as GUID
EXTERN _CLSID_InternetPrintOrdering as GUID
EXTERN _CLSID_FolderViewHost as GUID
EXTERN _CLSID_NamespaceWalker as GUID
EXTERN _CLSID_ImageRecompress as GUID
EXTERN _CLSID_TrayBandSiteService as GUID
EXTERN _CLSID_PassportWizard as GUID
EXTERN _CLSID_AttachmentServices as GUID

$endif


